/**********************************************************

* Filename					: cpucore_handler.js

* Purpose					: Exposes CPU Core API from signage

* Author(s)					: chamoknath.choudhury@lge.com, amber.pandit@lge.com

* Creation date				: April 20, 2016

**********************************************************/



(function(){



	module.exports = cpuCore;



	var spawn = require('child_process');



	function cpuCore(msg, socket) {

		//Expected msg format : {"subscribe" : true/false, "interval": milliseconds}

		var processStatusProtocol = socket._protocols['cpucore'];

		if(processStatusProtocol){

			clearInterval(processStatusProtocol);

		}

		if(msg.subscribe === true){

			//Interval because subscribe is true, it will send data at each interval

			if(msg.intervalValue && !isNaN(msg.intervalValue)){

				socket._protocols['cpucore'] = setInterval(function(){

					//Code for Command Execution and emit the data back to client

					getcpuCore(socket);

				}, msg.intervalValue);

			}else{

				response = {"returnValue": false, "result" : "Invalid Interval Value"};

				socket.emit('cpucore', response);

			}

		} else{

			//No Interval because subscribe is false, it will send data only once

			getcpuCore(socket);

		}

	}



	function getcpuCore(socket) {

		var response = {};

		try{

			var cmd = 'grep "cpu *" /proc/stat | awk \'{print $1}\'';

			var getcpuCore = spawn.exec(cmd, function(error, stdout, stdin){

				if(error){

					response = {"returnValue": false, "result" : error};

					socket.emit('cpucore', response);

				} else {

					var output = "";

					var cpuCores = stdout.split("\n");

					for(var i = 1; i < cpuCores.length - 1; i++){

						output = output + cpuCores[i] + "\n";

					}

					response = {"returnValue": true, "result" : output};

					socket.emit('cpucore', response);

				}

			});

		}catch(e){

			response = {"returnValue": false, "result" : e};

			socket.emit('cpucore', response);

		}

	}

})();