/**********************************************************

* Filename					: inodeinfo_handler.js

* Purpose					: Exposes iNode API from signage

* Author(s)					: chamoknath.choudhury@lge.com, amber.pandit@lge.com

* Creation date				: April 20, 2016

**********************************************************/



(function(){



	module.exports = iNodeInfo;



	var spawn = require('child_process');



	function iNodeInfo(msg, socket) {

		//Expected msg format : {"subscribe" : true/false, "interval": milliseconds}

		var iNodeInfoProtocol = socket._protocols['inodeinfo'];

		if(iNodeInfoProtocol){

			clearInterval(iNodeInfoProtocol);

		}



		if(msg.subscribe ===true){

			//Interval because subscribe is true, it will send data at each interval

			if(msg.intervalValue && !isNaN(msg.intervalValue)){

				socket._protocols['inodeinfo'] = setInterval(function(){

					//Code for Command Execution and emit the data back to client

					getINodeInfo(socket);

				}, msg.intervalValue);

			}else{

				response = {"returnValue": false, "result" : "Invalid Interval Value"};

				socket.emit('inodeinfo', response);

			}

		} else{

			//No Interval because subscribe is false, it will send data only once

			getINodeInfo(socket);

		}

	}



	function getINodeInfo(socket) {

		var response = {};

		try{

			var cmd = "date +\"%s\";/bin/busybox df -i 2>/dev/null | sed '1d' | sort | uniq | awk '{if(mount == $1 && inode==$2) print $6; else {print $1,$2,$3,$4,$5;print $6;mount=$1;inode=$2}}'";

			var killTailingProcess = spawn.exec(cmd, function(error, stdout, stdin){

				if(error){

					response = {"returnValue": false, "result" : error};

					socket.emit('inodeinfo', response);

				} else {

					formatINodeInfo(stdout, function(result){

						response = {"returnValue": true, "result" : result};

						socket.emit('inodeinfo', response);

					});

				}

			});

		}catch(e){

			response = {"returnValue": false, "result" : e};

			socket.emit('inodeinfo', response);

		}

	}



	function formatINodeInfo(stdout, callback) {



		var inodeinfo = {};

		var InodeStatus = [];

		var lastIndex = 0;

		var lines = stdout.split("\n");

		inodeinfo.date = +lines[0] * 1000;

		try{

			for(var iIndex=1;iIndex < lines.length;iIndex++) {

				var spaceIndex = lines[iIndex].indexOf(" ");

				if(spaceIndex==-1) {

					var mountOn = lines[iIndex].toString();

					var lastMountOnPath = InodeStatus[lastIndex]["mountedOn"];

					if(lastMountOnPath)

						InodeStatus[lastIndex]["mountedOn"]+= ";" + mountOn;

					else

						InodeStatus[lastIndex]["mountedOn"] = mountOn;

				}

				else {

					var arrLine = lines[iIndex].split(/\s+/);

					var inodeObj = {};

					inodeObj["fsPath"] = arrLine[0];

					inodeObj["iNodes"] = +arrLine[1];

					inodeObj["used"] = +arrLine[2];

					inodeObj["available"] = +arrLine[3];

					inodeObj["pUse"] = +arrLine[4].substring(0, arrLine[4].length - 1);

					inodeObj["mountedOn"] = "";

					InodeStatus.push(inodeObj);

					lastIndex = InodeStatus.length - 1;

				}

			}

			inodeinfo.inodeInfo = InodeStatus;

			callback(inodeinfo);

		}

		catch(err){

			inodeinfo.err = err;

			callback(inodeinfo);

		}

	}



})();