/**********************************************************

* Filename					: killtailprocess_handler.js

* Purpose					: Exposes Kill Tail Process API from signage

* Author(s)					: chamoknath.choudhury@lge.com, amber.pandit@lge.com

* Creation date				: April 19, 2016

**********************************************************/



(function(){



	module.exports = killProcess;



	var spawn = require('child_process');



	function killProcess(msg, socket) {

		//Expected msg format : {"subscribe" : true/false, "interval": milliseconds}

		var killTailProcessProtocol = socket._protocols['killtailprocess'];

		if(killTailProcessProtocol){

			clearInterval(killTailProcessProtocol);

		}

		if(msg.subscribe === true){

			//Interval because subscribe is true, it will send data at each interval

			if(msg.intervalValue && !isNaN(msg.intervalValue)){

				socket._protocols['killtailprocess'] = setInterval(function(){

					//Code for Command Execution and emit the data back to client

					killTailingProcess(msg.pid, socket);

				}, msg.intervalValue);

			}else{

				response = {"returnValue": false, "result" : "Invalid Interval Value"};

				socket.emit('killtailprocess', response);

			}

		} else{

			//No Interval because subscribe is false, it will send data only once

			killTailingProcess(msg.pid, socket);

		}

	}



	function killTailingProcess(pid, socket) {

		var response = {};

		try{

			var cmd = 'pkill -TERM -P ' + pid;

			var killTailingProcess = spawn.exec(cmd, function(error, stdout, stdin){

				if(error){

					response = {"returnValue": false, "result" : error};

					socket.emit('killtailprocess', response);

				} else {

					response = {"returnValue": true, "result" : stdout + stdin};

					socket.emit('killtailprocess', response);

				}

			});

		}catch(e){

			response = {"returnValue": false, "result" : e};

			socket.emit('killtailprocess', response);

		}

	}

})();