/**********************************************************

* Filename					: pmmodule_handler.js

* Purpose					: Exposes pmmodule API from signage

* Author(s)					: chamoknath.choudhury@lge.com, amber.pandit@lge.com

* Creation date				: April 20, 2016

**********************************************************/



(function(){



	module.exports = pmModule;



	var spawn = require('child_process');



	function pmModule(msg, socket) {

		//Expected msg format : {"subscribe" : true/false, "interval": milliseconds}

		var pmModuleProtocol = socket._protocols['pmmodule'];

		if(pmModuleProtocol){

			clearInterval(pmModuleProtocol);

		}

		if(msg.subscribe === true){

			//Interval because subscribe is true, it will send data at each interval

			if(msg.intervalValue && !isNaN(msg.intervalValue)){

				socket._protocols['pmmodule'] = setInterval(function(){

					//Code for Command Execution and emit the data back to client

					getPmModules(socket);

				}, msg.intervalValue);

			}else{

				response = {"returnValue": false, "result" : "Invalid Interval Value"};

				socket.emit('pmmodule', response);

			}

		} else{

			//No Interval because subscribe is false, it will send data only once

			getPmModules(socket);

		}

	}



	function getPmModules(socket) {

		var response = {};

		try{

			var cmd = '/usr/bin/PmLogCtl show 2>&1';

			var getPmModules = spawn.exec(cmd, function(error, stdout, stdin){

				if(error){

					response = {"returnValue": false, "result" : error};

					socket.emit('pmmodules', response);

				} else {

					response = {"returnValue": true, "result" : stdout};

					socket.emit('pmmodules', response);

				}

			});

		}catch(e){

			response = {"returnValue": false, "result" : e};

			socket.emit('pmmodules', response);

		}

	}



})();