/**********************************************************

* Filename					: procinfo_handler.js

* Purpose					: Exposes Proc Info API from signage

* Author(s)					: chamoknath.choudhury@lge.com, amber.pandit@lge.com

* Creation date				: April 19, 2016

**********************************************************/



(function(){



	module.exports = processList;



	var spawn = require('child_process');



	function processList(msg, socket) {

		//Expected msg format : {"subscribe" : true/false, "interval": milliseconds}

		var processListProtocol = socket._protocols['procinfo'];

		if(processListProtocol){

			clearInterval(processListProtocol);

		}

		if(msg.subscribe === true){

			//Interval because subscribe is true, it will send data at each interval

			if(msg.intervalValue && !isNaN(msg.intervalValue)){

				socket._protocols['procinfo'] = setInterval(function(){

					//Code for Command Execution and emit the data back to client

					getProcessList(socket);

				}, msg.intervalValue);

			}else{

				response = {"returnValue": false, "result" : "Invalid Interval Value"};

				socket.emit('procinfo', response);

			}

		} else{

			//No Interval because subscribe is false, it will send data only once

			getProcessList(socket);

		}

	}



	function getProcessList(socket) {

		var response = {};

		try{

			var cmd = "ps aux --sort=-rss,pcpu| awk '{if ($3>0 && $4>0 && $11!~/\\[/) print $2,$11}';ps aux|grep [Q]tWebProcess|awk '{print $2,$11,$12}';";

			var getProcessList = spawn.exec(cmd, function(error, stdout, stdin){

				if(error){

					response = {"returnValue": false, "result" : error};

					socket.emit('procinfo', response);

				} else{

					getCpuInfo(stdout, function(result){

						response = {"returnValue": true, "result" : result};

						socket.emit('procinfo', response);

					});

				}

			});

		}catch(e){

			response = {"returnValue": false, "result" : e};

			socket.emit('procinfo', response);

		}

	}



	function getCpuInfo(stdout, callback) {

		var process = [];

		var cpuprocinfo = [];

		var lines = stdout.split("\n");

		var qtProc = '/usr/bin/QtWebProcess';

		for (var i = 0; i < lines.length - 1; i++ ) {

			var values = lines[i].split(' ');

			var pid = parseFloat(values[0]); // pid

			var name = values[1];// command



			if (values.length == 3) {

				if (name == qtProc) {

					name = name + " " + values[2];

				}



				if (name == 'grep' || name == '/bin/sh') {

					continue;

				}

			} else if (name == qtProc) {

				continue;

			}



			if (pid == 'undefined' || pid == null || name == '-sh') {

				continue;

			}



			var process = {};

			process.pid = pid;

			process.pname = name;

			cpuprocinfo.push(process);

		}

		/*processList = {

				"processList": process

		};*/



		callback(cpuprocinfo);



	}



})();