/**********************************************************
 * Filename					: macinfo_handler.js
 * Purpose					: Exposes MAC Info API from signage
 * Author(s)					: chamoknath.choudhury@lge.com, amber.pandit@lge.com
 * Creation date				: June 9, 2016
 **********************************************************/

(function(){

	module.exports = systemInfo;

	var spawn = require('child_process');

	function systemInfo(msg, socket, service) {

		var response = {};
		//Expected msg format : {"subscribe" : true/false, "interval": milliseconds}
		var systemInfoProtocol = socket._protocols['systeminfo'];
		if(systemInfoProtocol){
			clearInterval(systemInfoProtocol);
		}
		if(msg.subscribe === true){
			//Interval because subscribe is true, it will send data at each interval
			if(msg.intervalValue && !isNaN(msg.intervalValue)){
				socket._protocols['systeminfo'] = setInterval(function(){
					//Code for Command Execution and emit the data back to client
					getSystemInfo(socket, service);
				}, msg.intervalValue);
			}else{
				response = {"returnValue": false, "result" : "Invalid Interval Value"};
				socket.emit('systeminfo', response);
			}
		} else{
			//No Interval because subscribe is false, it will send data only once
			getSystemInfo(socket, service);
		}
	}

	function getSystemInfo(socket, service){

		var response = {};

		service.call("luna://com.webos.service.tv.systemproperty/getSystemInfo", {keys: ["modelName", "firmwareVersion", "boardType"]}, function(message) {
			if(message.payload.returnValue){
				message = message.payload;
				delete message['returnValue'];
				response = {"returnValue": true, "result" : message};
			}else{
				response = {"returnValue": false, "result" : "error"};
			}
			socket.emit('systeminfo', response);
		});
	}
})();