/**********************************************************

* Filename					: taillog_handler.js

* Purpose					: Exposes Tail Log API from signage

* Author(s)					: chamoknath.choudhury@lge.com, amber.pandit@lge.com

* Creation date				: April 19, 2016

**********************************************************/



(function(){



	module.exports = tailLogs;



	var spawn = require('child_process');



	function tailLogs(msg, socket) {

		//Expected msg format : {"subscribe" : true/false, "interval": milliseconds}

		var tailLogProtocol = socket._protocols['taillogs'];

		if(tailLogProtocol){

			clearInterval(tailLogProtocol);

		}

		if(msg.subscribe === true){

			//Interval because subscribe is true, it will send data at each interval

			if(msg.intervalValue && !isNaN(msg.intervalValue)){

				socket._protocols['taillogs'] = setInterval(function(){

					//Code for Command Execution and emit the data back to client

					getTailLogs(socket);

				}, msg.intervalValue);

			}else{

				response = {"returnValue": false, "result" : "Invalid Interval Value"};

				socket.emit('taillogs', response);

			}

		} else {

			//No Interval because subscribe is false, it will send data only once

			getTailLogs(socket);

		}

	}



	function getTailLogs(socket) {

		var response = {};

		try{

			//var cmd = 'echo EXEC PID:$$; /usr/bin/test -e /var/log/messages && /usr/bin/tail /var/log/messages || /bin/echo Cannot access the Log file 1>&2';

			var cmd = 'echo EXEC PID:$$; /usr/bin/tail -f /var/log/messages';

			var getTailLogs = spawn.exec(cmd, function(error, stdout, stdin){

				if(error){

					response = {"returnValue": false, "result" : "error " + error};

					socket.emit('taillogs', response);

				} else {

					response = {"returnValue": true, "result" : stdout + stdin};

					socket.emit('taillogs', response);

				}

			});

		}catch(e){

			response = {"returnValue": false, "result" : "e : " + e};

			socket.emit('taillogs', response);

		}

	}

})();