// scripts/Event/EventDownload.js

(function() {
'use strict';

    /**
     * Objeto para controlar os eventos de download
     *
     * @class EventDownload
     * @type {Object}
     */
    var EventDownload = {};

    // aplica o controle de evento ao objeto
    Evento.applyTo(EventDownload);

    /////////////
    // eventos //
    /////////////

    /**
     * Método para atualizar os templates do layout
     *
     * @event finishDownloadFilesLayoutTemplate
     * @return {void}
     */
    EventDownload.bind('finishDownloadFilesLayoutTemplate', function () {
        // evento para recarregar o layout
        // TODO: isso deve ser refatorado. A janela não deve ser repasada dessa forma
        // var debouceLoadLayout = _.debounce(function __debouceLoadLayout() {
        //     EventLayout.trigger('loadLayout', [player4uc.window.getAll()[0], undefined, undefined, 1]);
        // }, 1000);

        // // chama a função
        // debouceLoadLayout();
    });

    /**
     * Evento para ser executado quando o arquivo selecao for processado.
     *
     * @event finishDownloadFilesSelecao
     * @return {void}
     */
    EventDownload.bind('finishDownloadFilesSelecao', function () {
        // exclue todos os arquivos de conteúdo desnecessários
        EventDownload.trigger('verifyFilesForDelete');
    });

    /**
    * Método para atualizar todas as play list de áudio
    *
    * @event resetPlayList
    * @return {void}
    */
    EventDownload.bind('resetPlayList', function () {
        // busca todas as janelas
        var appWindow = player4uc.window.getAll()['mainWindow-1'];
        var i;

        // reseta a lista
        appWindow.contentWindow.ClassAudio.resetList();

        // inicia a playlist
        applyAudioWindow (
            appWindow,
            appWindow.contentWindow.playerData
        );

        // console.info('EventDownload resetPlayList');
    });

    /**
    * Método para atualizar todos os layouts com as notícias novas
    *
    * @event getDownloadLayoutXML
    * @return {void}
    */
    EventDownload.bind('getDownloadLayoutXML', function () {
        // chama evento para atualizar a lista de notícias
        EventLayout.trigger('updatePlayListNewsLayout');

        // console.info('EventDownload getDownloadLayoutXML');
    });

    /**
     * Evento para verificar se existe mais arquivos do que o necessário
     *
     * @event verifyFilesForDelete
     * @return {void}
     */
    EventDownload.bind('verifyFilesForDelete', function __doneVerifyFilesForDelete() {

        // método para verificar se todos os arquivos são válidos para o player atual
        FileSyncSelecao.processFileSelecao(function __doneProcessFileSelecaoEvent() {
            // console.info("verifyFilesForDelete processFileSelecao");
        });

        // console.info('EventDownload verifyFilesForDelete');
    });

    /**
     * Evento para verificar se existe mais arquivos do que o necessário para notícias
     *
     * @event verifyFilesNewsForDelete
     * @return {void}
     */
    EventDownload.bind('verifyFilesNewsForDelete', function __doneVerifyFilesNewsForDelete() {

        // método para verificar se todos os arquivos são válidos para o player atual
        FileSyncRss.readAllFile(function __doneReadAllFileEvent(listFile) {
            FileSyncRss.verifyFileForDelete(listFile, function __doneVerifyFileForDelete() {
                // console.info("verifyFilesNewsForDelete processFileSelecao", listFile);
            });
        });

        // console.info('EventDownload verifyFilesNewsForDelete');
    });

   window.EventDownload = EventDownload;
}) (window);
