// scripts/Event/EventPlayerAudio.js

(function() {
'use strict';

    /**
     * Objeto para gerenciar eventos da playlist de áudio
     *
     * @class  EventPlayerAudio
     * @type {Object}
     */
    var EventPlayerAudio = {};

    // aplica o controle de evento ao objeto
    Evento.applyTo(EventPlayerAudio);

    /////////////
    // eventos //
    /////////////

    /**
    * Método para atualizar todas as play list de áudio
    *
    * @event playlistAudioPause
    * @return {void}
    */
    EventPlayerAudio.bind('playlistAudioPause', function (appWindow) {
        // classe da Playlist de áudio
        var classAudio = appWindow.ClassAudio;

        // pausa o áudio
        classAudio.stop();

        // console.log('EventPlayerAudio playlistAudioPause');
    });

    /**
     * Evento para executar o conteúdo da playlist de áudio
     *
     * @event playlistAudioPlayer
     * @param  {AppWindow} AppWindow
     * @return {void}
     */
    EventPlayerAudio.bind('playlistAudioPlayer', function (appWindow) {
        // classe da Playlist de áudio
        var classAudio = appWindow.ClassAudio;

        // pausa o áudio. DESATIVADO ATÉ A RELEASE COM PLAYLIST DE ÁUDIO
        // classAudio.play();

        // console.log('EventPlayerAudio playlistAudioPlayer');
    });


   window.EventPlayerAudio = EventPlayerAudio;
}) (window);
