(function (){

	function GenericDownload(_id, rootDirEntry, projectName, env4YouSee){
		// console.log('Iniciando GenericDownload ', _id, new Date());
		this.index = _id;
		GenericDownload.commonUrl = env4YouSee + '/common/';
		GenericDownload.rootDirEntry = rootDirEntry;
		GenericDownload.projectName = projectName;

		this.schedule(1000);
	}

	GenericDownload.prototype.schedule = function(timeout){
		var that = this;
		setTimeout(function(){
				that.download();
		}, timeout);
	}

	GenericDownload.prototype.download = function (){
		var genericItem = DownloadCenter.getGenericDownloadItem();

		if(genericItem == undefined){
			this.schedule(10000);
		}
		else{
            var fType = genericItem.type;
			var that = this;
			var urlDownload = GenericDownload.commonUrl + '/';
			var pathFilesMedia = GenericDownload.projectName + '/';
            var nameFile = genericItem.file;

            // timeout
            that.schedule(1000);

            // imagens
            if (fType == FileSync.FILE_TYPE_RSS_IMG || fType == FileSync.FILE_TYPE_LAYOUT_RSS_IMG) {
                urlDownload += 'imgnews/';

				//Verifica em qual pasta a imagem deve ser salva /imgnew ou /layout/imgnew
				pathFilesMedia += (fType == FileSync.FILE_TYPE_RSS_IMG ? FileSync.PLAYER_DIR_RSS_IMG : FileSync.PLAYER_DIR_LAYOUT_RSS_IMG) + '/';
            }

            // zip
            if (fType == FileSync.FILE_TYPE_RSS_TEMPLATE) {
                urlDownload += 'templates/';
                pathFilesMedia += FileSync.PLAYER_DIR_RSS_TEMPLATE + '/';
            }

            // verifica se o arquivo já existe
            FileSync.exists(
                pathFilesMedia + nameFile,
                function (fileExist) {

                    // caso o arquivo ainda não exista
                    if (!fileExist) {
                        return downloadContent();
                    }

                    // exclui a pasta do template
                    // descompacta o conteúdo
                    // caso o conteúdo seja zip
                    if (fType == FileSync.FILE_TYPE_RSS_TEMPLATE) {
                        // descompacta o conteúdo zip
                        return unzipTemplate();
                    }

                    // callback
                    // _log('O arquivo ', nameFile, ' já foi baixado.');
                    // remove o download
                    DownloadCenter.remove(genericItem, DownloadCenter.COMPLETED);
                },
                false
            );

            /**
             * Método para realizar download do conteúdo
             * @param  {Function} callback
             * @return {void}
             */
            function downloadContent(callback) {
                // forçar o download
                // TODO: PARA FORÇA O DOWNLOAD DE UM CONTEÚDO, PRIMEIRO O CONTEÚDO DEVE SER EXCLUÍDO

                // url para download
                urlDownload += nameFile;

                // logs
                // _log('INICIANDO O DONWLOAD - GenericDownload.download: ' + nameFile);

                // inicia o download dos arquivos
                player4uc.download.start({
                    url: urlDownload,
                    path: pathFilesMedia,
                }, function __doneDownloadStart(error, data){
                    var statusDownload = DownloadCenter.COMPLETED

                    // em caso de erro
                    if (error) {
                        statusDownload = DownloadCenter.FAILED;
                    }

                    // caso o conteúdo seja zip
                    if (fType == FileSync.FILE_TYPE_RSS_TEMPLATE) {
                        // descompacta o conteúdo zip
                        unzipTemplate();
                    }

                    // remove o download
                    DownloadCenter.remove(genericItem, statusDownload);
                });
            }

            /**
             * Método para descompactar o template
             *
             * @todo: não gosto disso, depois é preciso refatorar para injetar as necessidades
             * @return {void}
             */
            function unzipTemplate() {
                window.sync.unzipFile(GenericDownload.rootDirEntry, pathFilesMedia + nameFile, urlDownload, function (result) {
                    // em caso de erro
                    if (!result) {
                        statusDownload = DownloadCenter.FAILED;
                    }

                    // excluindo zips
                    player4uc.filesystem.rmdir(pathFilesMedia + nameFile, {recursive: true}, function __doneDeleteFile(error, data) {
                        console.log({
                            'Arquivos de genérico excluído':genericItem.file,
                            'error': error,
                            'data': data,
                        });
                    });

                    // logs
                    // _log(
                    //     'GenericDownload.download: downloadContent unzipTemplate',
                    //     {
                    //         'statusDownload': statusDownload,
                    //         'pathFilesMedia + genericItem.file': pathFilesMedia + genericItem.file
                    //     }
                    // );
                });
            }
		}
	};

	window.GenericDownload = GenericDownload;
})();
