(function (){

    /**
     * Classe para realizar o download das músicas da playlist de áudio
     *
     * @class MediaAudioDownload
     * @param {integer} _id
     * @param {Directory} rootDirEntry
     * @param {string} projectName
     * @param {string} env4YouSee
     */
	function MediaAudioDownload(_id, rootDirEntry, projectName, env4YouSee){
		// console.log('Iniciando MediaAudioDownload ', _id, new Date());
		this.index = _id;
		MediaAudioDownload.url = env4YouSee + '/common/videos/';
		MediaAudioDownload.rootDirEntry = rootDirEntry;
		MediaAudioDownload.projectName = projectName;
	}

    /**
     * Método para download do arquivo
     *
     * @method download
     * @param  {object}   mediaItem
     * @param  {Function} callback
     * @return {void}
     */
	MediaAudioDownload.prototype.download = function (mediaItem, callback){
        var mimetype = 'video/mp4';

        // caso não tenha nada
		if(mediaItem != undefined){
			// console.log('MediaAudioDownload ', this.index ,'Download do item ', mediaItem);
			var mediaType = mediaItem.file.split('.').pop();

            // mimetype
            if (mediaType == 'mp3') {
                mimetype = 'audio/mpeg3';
            }

			// save video files
			if (mediaType == 'mp3' || mediaType == 'mp4') {
				var that = this;
				var xhr = new XMLHttpRequest();
				xhr.open('GET', MediaAudioDownload.url + mediaItem.file + '?' + new Date().getTime());
				xhr.responseType = "arraybuffer";

                /**
                 * Método para quando a requisição retornar
                 * @return {void}
                 */
				xhr.onload = function() {
					if (this.status == 200) {
						sync.writeDownloadedFile(MediaAudioDownload.rootDirEntry, MediaAudioDownload.projectName + '/' + FileSync.PLAYER_DIR_AUDIO,
							mediaItem.file, this.response, mimetype, function doneWriteDownloadFile() {
                                // callback
                                callback(mediaItem, DownloadCenter.COMPLETED);

                                // console.log('MediaAudioDownload download: PRONTO');
                            });

					}else if(this.status == 404){
                        // callback
                        callback(mediaItem, DownloadCenter.NOT_FOUND);
					}

				}

                /**
                 * Método para tratar erros na requisição
                 * @return {void}
                 */
				xhr.onerror = function(){
                    // callback
                    callback(mediaItem, DownloadCenter.FAILED);
				}

				xhr.send();
			}
		}
	};

	window.MediaAudioDownload = MediaAudioDownload;
})();
