(function (){

	function MediaDownload(_id, rootDirEntry, projectName, env4YouSee){
		// console.log('Iniciando MediaDownload ', _id, new Date());
		this.index = _id;
		MediaDownload.url = env4YouSee + '/common/videos/';
		MediaDownload.rootDirEntry = rootDirEntry;
		MediaDownload.projectName = projectName;
	}


	MediaDownload.prototype.download = function (mediaItem, callback){

		if(mediaItem != undefined){

            // console.log('---> Download do item ', mediaItem);

			var mediaType = mediaItem.file.split('.').pop();
				// save video files
            var extension = ['mp4', 'jpeg', 'png', 'jpg', 'gif', 'zip', 'html', 'htm'];

            var pathFilesMedia = MediaDownload.projectName + '/' + FileSync.PLAYER_DIR_MEDIA + '/';

            // nome do arquivo
            // caso seja zip o nome da pasta deve ser removido
            var nameFile = (mediaType != 'zip'? mediaItem.file : mediaItem.file.split('.')[0] + '/index.html');

            // caso seja para forçar
            if ('force' in mediaItem && mediaItem.force) {
                // video
                if (mediaType != 'zip') {
                    player4uc.filesystem.rm(pathFilesMedia + nameFile, function __doneDeleteFile() {});
                }
                else {
                    // zip
                    player4uc.filesystem.rmdir(pathFilesMedia + mediaItem.file.split('.')[0], {recursive: true}, function __doneDeleteFile() {});
                }
            }

            // verifica se o arquivo já existe
            FileSync.exists(
                pathFilesMedia + nameFile,
                function (fileExist) {
                    // caso o arquivo já exista
                    if (!fileExist) {
                        return downloadContent();
                    }

                    // callback
                    // _log('O arquivo ', mediaItem.file, ' já foi baixado.');
                    callback(mediaItem, DownloadCenter.FOUND);
                },
                false
            );

            /**
             * Método para realizar o download do conteúdo
             * @return {void}
             */
            function downloadContent() {
                if (extension.indexOf(mediaType) != -1) {

    				var that = this;
                    var date = new Date();

                    // forçar o download
                    var hash = '?';

                    if ('force' in mediaItem && mediaItem.force == true) {
                        hash += date.getTime();
                    }

                    var urlDownload = MediaDownload.url + mediaItem.file + hash;

                    // inicia o download dos arquivos
                    player4uc.download.start({
                        url: urlDownload,
                        path: pathFilesMedia,
                    }, function __doneDownloadStart(error, data){
                        var statusDownload = DownloadCenter.COMPLETED

                        // em caso de erro
                        if (error) {
                            statusDownload = DownloadCenter.FAILED;
                        }

                        // logs
                        _log('MediaDownload download:' + statusDownload, mediaItem.file);

                        // caso o conteúdo seja zip
                        if (mediaType == 'zip') {
                            // descompacta o conteúdo zip
                            window.sync.unzipFile(MediaDownload.rootDirEntry, pathFilesMedia + mediaItem.file, urlDownload, function (result) {
                                // em caso de erro
                                if (!result) {
                                    statusDownload = DownloadCenter.FAILED;
                                }

                                // logs
                                // _log("Conteúdo " + mediaItem.file + " foi descompactado com " + statusDownload);

                                // callback
                                callback(mediaItem, statusDownload);
                            });
                            return;
                        }

                        // callback
                        callback(mediaItem, statusDownload);

                    });

    			}
            }
		}
	};

	window.MediaDownload = MediaDownload;
})();
