(function (_global) {
    /* globals Player, playlistManager, FileSyncCarrossel, escape, CarrosselVideoPlayer, DataContent, _, FileSync, async, player4uc, console, _log, _logError, DownloadCenter, sync, LayoutArea, playlistVideo */
    'use strict';

    /**
     * Classe para controlar conteúdo do tipo vídeo
     *
     * @todo TODO O CONTROLE DE CARROSSEIS DESSA CLASSE DEVEM SER REMOVIDOS PARA OUTRA CLASSE
     *
     * @constructor VideoPlayer
     * @class VideoPlayer
     * @param {Content} classContent
     */
    function VideoPlayer(classContent, classCarrosselVideoPlayer)
    {
        // lista de eventos
        this.events = {};

        // caminho para o conteúdo
        this.pathContent = classContent.getPathContent;

        // caminho para executar o conteúdo
        this.pathContentPlay = classContent.getPathContentPlay;

        // id da playlist a ser tocada
        // this.currentList;

        // numero máximo de playlists
        this.totalList = 0;

        // permitir atualizar a playlist
        // this.updatePlaylist;

        // tag para permitir que o vídeo seja tocados pela primeira vez
        this.authChangePlayList = true;

        // classe para controlar a lista de carrosseis
        this.classCarrosselVideoPlayer = classCarrosselVideoPlayer;

        this.fileForPlaylist = [];

        // TODO: isso aqui  é temporário
        this.GAMBFinishVideo = true;

        this.objectFlags = {
            allFilesExist: false,
            contentSchedule: false,
        };

        // lista de arquivos que ainda não foram baixados
        this.listFilesNotExists = [];
        // lista com todos os arquivos de vídeo
        this.listFiles = [];
    }

    /**
     * Lista de extenções tidas como vídeo
     * @type {Array}
     */
    VideoPlayer.prototype.listExtVideo = [
        'mp4'
    ];

    /**
     * Variável que contém o nome dos arquivos de playlist de vídeos
     * @type {String}
     */
    VideoPlayer.prototype.nameFilePlaylist = 'playlistVideo_<idPlaylist>.txt';

    /**
     * Variável que contém o nome do arquivo para os carrosseis
     * @type {String}
     */
    VideoPlayer.prototype.nameFilePlaylistCarrossel = 'playlistVideo_categoria_<idPlaylist>.txt';

    /**
     * Método para iniciar o vídeo
     *
     * @method loadContent
     * @return {void}
     */
    VideoPlayer.prototype.loadContent = function __doneLoadContent ()
    {
        // caso não exista a playlist
        var playlist = this.getPlaylist();
        var playlistFiles = this.getPlaylistFile();
        var that = this;

        if (typeof playlist !== 'object') {
            return;
        }

        // caso a playlist esteja vazia
        if (playlistFiles && !playlistFiles.length) {
            return;
        }

        // flag: caso todos os arquivos ainda não esteja em disco
        this.objectFlags.allFilesExist = false;
        // flag: caso não exista arquivos com programação
        this.objectFlags.contentSchedule = false;
        // zera os arquivos que ainda precisam ser baixados
        this.listFilesNotExists = [];
        // zera a lista
        this.listFiles = [];

        var extFile = '';
        var i, a = 0;

        var listOfList = [];
        var listOfListCarrossel = [];
        var listCarrossel = [];

        var resolution, encode;

        // evita que o player encave as chamadas
        clearTimeout(that.loadContentTimeout);

        // testar se todos os arquivos da playlist de tipo vídeo existem
        for (i in playlist) {
            extFile = '';

            // extenção do arquivo
            if ('arquivo' in playlistFiles[playlist[i]] && playlistFiles[playlist[i]].arquivo) {
                extFile = playlistFiles[playlist[i]].arquivo.split(".")[1];
            }

            // carrossel
            if (playlistFiles[playlist[i]].tipo === FileSync.TYPE_CARROSSEL) {
                listOfListCarrossel.push(playlistFiles[playlist[i]]);
            }

            // verifica a resolução e condião do vídeo
            // arquivos em que a extenção seja de tipo de vídeo
            var params = playlistFiles[playlist[i]].params || {};
            if (
                this.listExtVideo.indexOf(extFile) === -1 ||
                ('resolution' in params && params.resolution !== resolution) ||
                ('encode' in params && params.encode !== encode)
            ) {
                // gerando lista de playlists
                a++;
                continue;
            }

            // caso o conteúdo esteja vencido
            if (!Player.prototype.dateValidate(playlistFiles[playlist[i]])) {
                // flag: caso exista arquivos com programação
                this.objectFlags.contentSchedule = true;

                continue;
            }

            listOfList[a] = listOfList[a] || [];
            listOfList[a].push(playlistFiles[playlist[i]]);
        }

        // adiciona a última playlist de vídeos
        listOfList = _.compact(listOfList);

        // número máximo de playlist
        this.totalList = listOfList.length;

        // lista dos arquivos por playlist
        this.fileForPlaylist = listOfList;

        /**
         * Método para ler o arquivo de categoria
         * @param  {Array} listFiles
         * @param  {Function} endCallbackFileCategoria
         */
        function readFileCategoria (listFiles, endCallbackFileCategoria)
        {
            var listFilesCarrossel = {};

            async.eachSeries(listFiles, function __doneSeries(item, callbackNext) {
                // name file
                var media = window.projectName + '/' + FileSync.PLAYER_DIR_JSON + '/' + FileSyncCarrossel.getNameFile(item.arquivo);

                // ler o arquivo xml
                FileSync.readJSONFile(window.rootDirEntry, media, function doneReadJSONFile(jsonFile, error) {

                    // em caso de erros
                    if (_.isNull(jsonFile) || error) {
                        // download do arquivo carrossel
                        FileSyncCarrossel.downloadFileMedia(sync.urlDownloadJson + '/' + FileSyncCarrossel.getNameFile(item.arquivo), function () {
                            // callback
                            return endCallbackFileCategoria();
                        });
                    }

                    // adicionado lista de arquivos
                    listFilesCarrossel['cat_' + item.arquivo] = jsonFile.itens;

                    // callback each
                    callbackNext();
                });
            }, function __doneEachSeriesReadFileCategoria() {
                // callback
                endCallbackFileCategoria (listFilesCarrossel);
            });
        }

        // verifica se vai ser preciso verificar os arquivos de carrossel
        if (!listOfListCarrossel.length) {
            // verifica todos os arquivos
            return verifyFiles();
        }

        // ler os arquivos de categoria
        readFileCategoria(listOfListCarrossel, function __done(listVideo) {

            // em caso de erros
            if (!listVideo) {
                that.loadContentTimeout = setTimeout(function() {that.loadContent();}, 1000);
                return;
            }

            var listOfList = {};
            for (var key in listVideo) {
                listOfList[key] = [];
                for (var i in listVideo[key]) {
                    // caso o conteúdo esteja vencido
                    if (!Player.prototype.dateValidate(listVideo[key][i])) {
                        // flag: caso exista arquivos com programação
                        that.objectFlags.contentSchedule = true;

                        continue;
                    }

                    // caso não seja vídeo
                    if (that.listExtVideo.indexOf(listVideo[key][i].arquivo.split(".")[1]) === -1) {
                        continue;
                    }

                    // adiciona vídeo
                    listOfList[key].push(listVideo[key][i]);
                }

            }
            listVideo = listOfList;

            // lista dos carrosseis
            listOfListCarrossel = listVideo;

            // lista dos arquivos dos carrosseis
            listCarrossel = _.union(_.map(listVideo, function(arr) { return arr;}));

            // seta todos os objectos da lista carrosseis
            that.classCarrosselVideoPlayer.setListFiles(listVideo);

            // reseta a lista de carrosseis
            // that.classCarrosselVideoPlayer.createCurrentFile();

            // verifica todos os arquivos
            verifyFiles();
        });

        /**
         * Método para remover das playlist os arquivos que ainda não estão em disco
         * @param  {array} playlist
         * @param  {array} filesNotExist
         * @return {array}
         */
        function removeFilesPlaylist (playlist, filesNotExist) {
            var newPlaylist = [];
            for (var i in playlist) {
                // caso seja um array
                if (_.isArray(playlist[i])) {
                    newPlaylist.push(removeFilesPlaylist(playlist[i], filesNotExist));
                    continue;
                }

                // caso seja um objeto
                if (_.isObject(playlist[i])) {
                    // caso o arquivo exista em disco
                    if (!_.findWhere({"arquivo": playlist[i].arquivo}, filesNotExist)) {
                        newPlaylist.push(playlist[i]);
                    }
                }
            }

            return newPlaylist;
        }


        /**
         * Método para verificar se os arquivos existem
         * @return {void}
         */
        function verifyFiles() {
            that.listFiles = _.union(listOfList, listCarrossel);


            // init donwload all files
            // window.verifyPlayerContent.donwloadContentVideo = false;


            // verifica se da lista de vídeo todos já foram baixados
            that.contentExists (that.listFiles, function __done(allFilesExist, listFileNotExist) {

                // caso o arquivo não exista
                if (!allFilesExist) {
                    //AGUARDAR E REPETIR O PROCESSO DE DOWNLOAD DO CONTEÚDO
                    // that.loadContentTimeout = setTimeout(function() {that.loadContent();}, 2000);

                    // modifica os arrays com os vídeos para gerar somente dos vídeo que tem em disco
                    listOfList = removeFilesPlaylist(listOfList, listFileNotExist);
                    listCarrossel = removeFilesPlaylist(listCarrossel, listFileNotExist);

                    // flag: caso todos os arquivos ainda não esteja em disco
                    that.objectFlags.allFilesExist = false;
                    // lista de arquivos que ainda não foram baixados
                    that.listFilesNotExists = listFileNotExist;
                }

                /**
                 * Método para gerar a playlist de vídeos
                 * @param  {array} listFiles Playlist de vídeo
                 * @return {void}
                 */
                function createFilePlaylistVideo(listFiles, nameFile, endCallback)
                {

                    var stringList = '';
                    var pathFilePlaylist = that.pathContentPlay + nameFile;
                    var i;

                    // gerar a string a ser persistida na playlist
                    for(i in listFiles) {
                        stringList += 'File:////mnt/lg/appstore/scap/contents/' + that.pathContentPlay + listFiles[i].arquivo + "\n";
                        // stringList += that.pathContentPlay + listFiles[i].arquivo + "\n";
                    }

                    // cria o arquivo de playlist
                    player4uc.filesystem.writeFile(pathFilePlaylist, stringList, undefined, {noEncode: true}, function (error) {

                        // em caso de erro
                        if (error) {
                            _logError("Ops. Não foi possível gerar a playlist de vídeo.");

                            // será preciso tentar gerar a lista novamente
                            that.loadContentTimeout = setTimeout(function() {that.loadContent();}, 2000);

                            return false;
                        }
                        // logs
                        // _log("Playlist de vídeo gerada com sucesso.", stringList);

                        // callback
                        endCallback();
                    });
                }

                var i = 0;
                async.series([
                    /**
                     * Método para gerar os arquivos de playlist de vídeo
                     * @param  {Function} endCallbackNext
                     */
                    function __filePlaylist(endCallbackNext) {

                        // caso não exista nehum vídeo
                        if (!listOfList.length) {
                            // passa para a próxima função
                            return endCallbackNext(null, 1);
                        }

                        // gera um arquivo de extenção txt com a playlist a ser executada.
                        async.eachSeries(listOfList, function __doneEachSeries(listVideo, eachNext) {

                            // cria playlists
                            createFilePlaylistVideo(listVideo, that.getNameFile(i), eachNext);

                            i++;
                        }, function __done() {
                            // passa para a próxima função
                            endCallbackNext(null, 1);
                        });
                    },

                    /**
                     * Método para gerar os arquivos de playlist de carrossel
                     * @param  {Function} endCallbackNext
                     */
                    function __filePlaylistCarrossel(endCallbackNext) {

                        // caso não exista carrosseis
                        if (!Object.keys(listOfListCarrossel).length) {
                            // passa para a próxima função
                            return endCallbackNext(null, 2);
                        }

                        // cria vídeo para as categorias
                        async.forEachOf(listOfListCarrossel, function __done(listFiles, categoria, eachNext) {
                            for (var c in listFiles) {
                                // cria a playlists de carrossel
                                createFilePlaylistVideo([listFiles[c]], that.getNameFileCarrossel(categoria.replace("cat_", ''), c), eachNext);
                            }
                        });

                        // passa para a próxima função
                        endCallbackNext(null, 2);
                    }

                ], function __doneSeries(error, result) {
                    console.debug("----> TODOS OS ARQUIVOS FORAM GERADOS <----");

                    // em caso de errors
                    if (error) {
                        // log
                        _logError('Não foi possível processar todos os arquivos da playlist de vídeo.', result);

                        // reinicia o processo
                        return that.loadContent();
                    }

                    that.listFiles = _.reduceRight(that.listFiles, function(a, b) { return a.concat(b); }, []);

                    // caso fique pronto a playlist irá ser reiniciada
                    // playlistManager.resetPlaylistCurrent();

                    // finish donwload all files
                    // window.verifyPlayerContent.donwloadContentVideo = true;
                });
            });
        }
    };

    /**
     * Método para retornar o nome do arquivo da playlist
     * @param  {integer} idPlaylist
     * @return {void}
     */
    VideoPlayer.prototype.getNameFile = function __doneGetNameFile (idPlaylist)
    {
        return this.nameFilePlaylist.replace("<idPlaylist>", idPlaylist);
    };

    /**
     * Método para retornar o nome do arquivo da playlist
     * @param  {integer} idPlaylist
     * @return {void}
     */
    VideoPlayer.prototype.getNameFileCarrossel = function __doneGetNameFileCarrossel (idPlaylist, position)
    {
        var stringReplace = idPlaylist + "_" + position;
        return this.nameFilePlaylistCarrossel.replace("<idPlaylist>", stringReplace);
    };

    /**
     * Método para adicionar a playlist na tag Vídeo
     * @param  {ElementHtml} ElementVideo
     * @param  {Integer} idCarrossel
     */
    VideoPlayer.prototype.loadPlaylistInTagVideo = function __doneLoadPlaylistInTagVideo (ElementVideo, idCarrossel, callback)
    {
        // callback
        callback = callback || function() {};

        // * caso os vídeos ainda não estiverem prontos para tocar
        // essa função não deve ser chamada
        // * caso o elemento ainda não exista
        // * Caso algum vídeo ainda esteja tocando
        if (!ElementVideo || !this.GAMBFinishVideo) {
            return callback();
        }

        // caso os eventos já tenham sido registrados
        // é porque a tag vídeo já tem playlist
        if (ElementVideo && !ElementVideo.lastChild) {
            // registra todos os eventos
            this.registerEvents();
        }

        // para o vídeo
        ElementVideo.pause();

        // redimensiona o vídeo
        this.resizeVideo(ElementVideo);

        // remove todos as playlist de vídeo
        while(ElementVideo.lastChild) {
            ElementVideo.lastChild.remove();
        }

        var nameFile = this.getNameFile(this.currentList);
        // caso seja um carrossel
        if (idCarrossel) {
            nameFile = this.classCarrosselVideoPlayer.getNext(idCarrossel);
        }

        // caminho para o arquivo da playlist
        var pathFilePlaylist = '../content/' + this.pathContentPlay + nameFile;

        var options = {};
        options.htmlMediaOption = {};
        options.htmlMediaOption.useUMSMediaInfo = true;

        // carrega a lista na tag vídeo
        var source = document.createElement("source");
        source.setAttribute('src', pathFilePlaylist);
        source.setAttribute('type','video/mp4;mediaOption=' + escape(JSON.stringify(options)));

        ElementVideo.appendChild(source);

        // load vídeo
        ElementVideo.load();

        // não autoriza a troca de playlist
        this.authChangePlayList = false;

        // callback
        setTimeout(callback, 100);

        // log
        _log("---> VIDEO: Tocando a playlist: " + pathFilePlaylist);
    };

    /**
     * Método para registrar eventos do vídeo
     *
     * @method registerEvents
     * @return {void}
     */
    VideoPlayer.prototype.registerEvents = function __doneRegisterEvents ()
    {
        var that = this;

        /**
         * Flag para controlar quando o vídeo disparar um erro
         * @type {Boolean}
         */
        var flagError = false;

        // elemento vídeo
        var ElementVideo = this.getElementPlayer();

        // caso o elemento html ainda não esteja carregado
        if (!ElementVideo) {
            return;
        }

        // remove todos os eventos
        // removeEvents(ElementVideo);

        // registra evento para o player
        ElementVideo.addEventListener("umsmediainfo", umsmediainfo, false);

        /**
         * Evento error
         * @return {[type]} [description]
         */
        function errorEventUmsmediainfo(e) {
            // para o vídeo
            ElementVideo.pause();

            // autoriza a troca de playlist
            that.authChangePlayList = true;

            // reseta a playlist
            _logError("A playlist está sendo resetada.");
            that.GAMBFinishVideo = true;
            playlistManager.resetPlaylistCurrent(true);

            // flag que permite que esse conteúdo seja chamado
            // está flag está no arquivo de background.js
            window.controllPlayerContent = undefined;

            // TODO: ISSO DEVE SER REMOVIDO DAQUI
            window.classPlayer.loading.style.display = 'block';

            // remove o timeOut que verifica se o evento chamou corretamente.
            that.clearTimeouts();

            // chama o próximo conteúdo
            eventEnd(true);
        }

        /**
         * Evento a ser executado a transição de vídeo
         * @param  {Object} e
         */
        function umsmediainfo(e) {
            var eventCheck;

            try {
                eventCheck = JSON.parse(e.detail);
            } catch(ErrorException) {
                console.error('Ops. Aconteceu um problema ao tentar realizar o parse no JSON. A playlist será reiniciada.', ErrorException);

                return errorEventUmsmediainfo(ErrorException);
            }

            console.debug("--> UMSMEDIAINFO", e.detail);

            // if (eventCheck.type === "playbackNotificationInfo" && eventCheck.info === "loadCompleted") {
            //     console.debug("--->loadCompleted");
            //     return that.resizeVideo(ElementVideo);
            // }

            // exibe o conteúdo
            if (
                (eventCheck && !('type' in eventCheck) || eventCheck.type === 'playbackNotificationInfo') &&
                (eventCheck && !('info' in eventCheck) || eventCheck.info === 'playing')
            ) {
                // exibe o conteiner
                that.showContainer(that.getElementContainer(), 'video');

                // redimensiona o vídeo
                that.resizeVideo(ElementVideo);
            }

            // media de prevenção
            if (eventCheck && !('type' in eventCheck) || eventCheck.type === 'error') {
                console.error("----> VIDEO:", JSON.stringify(eventCheck));
                // ElementVideo.load();
                // ElementVideo.play();

                // não sei o motivo da tv disparar o código 700.
                // ainda estamos investigando, mas por enquando estou ignorando o código 700
                if ('errorCode' in eventCheck && errorCodeeventCheck != "700") {
                    // * essa flag se fez necessário já que o evento de erro é disparado várias vezes
                    // para um mesmo vídeo com erros diferentes
                    // * Caso o vídeo também já tenha terminado
                    if (flagError || that.GAMBFinishVideo) {
                        return;
                    }
                    flagError = true;

                    // evento em caso de erro
                    return errorEventUmsmediainfo(e);
                }

            }

            // logs
            // console.log("EVENTO umsmediainfo", e.detail);

            // caso não seja um evento do tipo gapless
            if (eventCheck.type !== 'userDefinedChanged' || !('gapless' in eventCheck.info)) {
                return;
            }

            // Caso o evento EOP já tenha sido disparado
            if (that.GAMBFinishVideo) {
                return;
            }

            // quanto o vídeo acabou
            if(eventCheck.info.gapless.eventType === "EOF"){
                console.debug("---> VIDEO: Evento EOF");

                // chama o próximo conteúdo
                eventEnd();
            }
            // quando o vídeo está para acabar
            // else if(eventCheck.info.gapless.eventType === "pre_EOF"){
            //     console.debug("---> VIDEO: Evento pre_EOF");
            // }
            // quando acaba de toca toda a playlist
            else if(eventCheck.info.gapless.eventType === "EOP"){
                // logs
                console.debug("---> VIDEO: Evento EOP");

                // para o vídeo
                ElementVideo.pause();

                // autoriza a troca de playlist
                that.authChangePlayList = true;

                // carrega a próxima playlist
                that.GAMBFinishVideo = true; // preciso que seja alterado antes da função eventEnd
                that.nextPlaylist(ElementVideo, function __done() {
                    // chama o póximo conteúdo
                    eventEnd();
                });

            }
        }

        /**
         * Evento que é executa quando o vídeo acaba
         * @return {void}
         */
        function eventEnd(videoError)
        {
            var item = that.getObjectItem();
            // logs
            _log("---> FIM VIDEO: ", item);

            // GAMB, provisório até encontrar outra solução
            that.GAMBFinishVideo = !videoError;

            // remove o timeOut que verifica se o evento chamou corretamente.
            that.clearTimeouts();

            // callback
            var callback = that.getCallback();
            if (callback) {
                return callback(null, item);
            }

            removeEvents();
        }

        /**
         * Método para remover todos os eventos de vídeo
         *
         * @method removeEvents
         * @return {void}
         */
        function removeEvents ()
        {
            ElementVideo.removeEventListener('umsmediainfo', umsmediainfo, false);
        }
    };

    /**
     * Método para resetar a playlist de vídeo
     * @method resetPlaylistCurrent
     */
    VideoPlayer.prototype.resetPlaylistCurrent = function __doneResetPlaylistCurrent()
    {
        // reseta o valor
        var that = this;

        // elemento html
        var ElementVideo = this.getElementPlayer();

        // remove os eventos registrados
        this.clearTimeouts();

        // reseta a playlist
        // Esse valor deve ser undefined, para que a playlist de vídeos saiba que a posição inicial
        // será 0
        this.currentList = undefined;

        // reseta a playlist de carrossel
        CarrosselVideoPlayer.resetPlaylist();

        // _log("---> VIDEO this.GAMBFinishVideo", this.GAMBFinishVideo);
        if (!this.GAMBFinishVideo) {
            // foi adicionado o timeout para aguardar o processamento da tv
            var item = that.getObjectItem();
            var callback = that.getCallback();

            // exibe janela de loading de arquivos
            window.classPlayer.loading.style.display = 'block';

            // caso o vídeo esteja sendo tocado quando a playlist é resetada
            _log("Aguarde! Em 3 segundos o player voltará a tocar.");
            // será necessário criar outra tag vídeo
            playlistVideo.reloadTagVideo();
            setTimeout(function() {
                // callback
                if (callback) {
                    return callback(null, item);
                }
            }, 3000);

            // autoriza a atualização
            this.authChangePlayList = true;
            this.GAMBFinishVideo = true;
            ElementVideo = this.getElementPlayer();
        }

        // carrega a playlist
        this.nextPlaylist(ElementVideo);
    };

    /**
     * Método para remover todos os timeout utilizado para controlar os eventos de vídeo
     * @method clearTimeouts
     */
    VideoPlayer.prototype.clearTimeouts = function __doneClearTimeouts()
    {
        clearTimeout(this.timeOutFinishVideo);
        clearTimeout(this.timeoutVerifyPlayVideo);
    };

    /**
     * Método para carregar a próxima playlist
     *
     * @method nextPlaylist
     * @param  {ElementHtml} ElementVideo
     * @param  {integer} idCarrossel Id do carrossel a ser tocado
     */
    VideoPlayer.prototype.nextPlaylist = function __doneNextPlaylist(ElementVideo, callback)
    {
        var that = this;

        // callback
        callback = callback || function () {};


        /////////////////////////////////
        // verifica o próximo conteúdo //
        /////////////////////////////////

        // faz com que o conteúdo seja carregado de forma imediata
        var idCarrossel;
        var itemCurrent;

        if (playlistManager.playlistStatus.current === false) {
            itemCurrent = 0;
        } else {
            itemCurrent = playlistManager.playlistStatus.current + 1; // Quando a playlist for reseta, esse valor virá como -1

            // TODO: REFATORA. Já existe um método na playlistManager, porém também será preciso refatora-lo
            if (itemCurrent > (playlistManager.currentPlaylist.length - 1)) {
                // caso o elemento venha 0 ou -1 adequa o contador do próximo item
                itemCurrent = 0;
            }
        }

        // TODO GAMB: DEPOIS PASSA TUDO ISSO PARA UM FUNÇÃO
        var objectNext = playlistManager.getPlaylistItem(itemCurrent);

        if (!objectNext) {
            _log("Não existe conteúdos a serem tocados.");
            return callback();
        }

        // extenção do arquivo
        var ext = '';
        if ('arquivo' in objectNext && objectNext.arquivo) {
            ext = objectNext.arquivo.split('.').pop();
        }

        /////////////////////////////////
        // verifica o próximo conteúdo //
        /////////////////////////////////

        if (objectNext.tipo === FileSync.TYPE_CARROSSEL) {
            idCarrossel = objectNext.arquivo;

            // solução parcial
            this.authChangePlayList = true;
        } else {
            // caso o próximo conteúdo seja diferente de vídeo ou carrossel
            if ([FileSync.TYPE_MOVIE, FileSync.TYPE_CARROSSEL].indexOf(objectNext.tipo) === -1 || ext !== 'mp4') {

                _log("Conteúdo não é do tipo vídeo. Tipo:" + objectNext.tipo);
                return callback();
            }
        }

        // caso o conteúdo de vídeo esteja vencido, o player não pode trocar a playlist de vídeo
        if (ext === 'mp4' && !Player.prototype.dateValidate(objectNext) && !this.authChangePlayList) {
            return callback();
        }


        // caso a playlist já tenha sido alterada
        // e ainda não tenha sido tocada
        if (!this.authChangePlayList) {
            return callback();
        }

        // zera o contador
        this.flagCountErrorPlay = 0;

        // caso o vídeo a ser tocado seja carrossel o contador não
        // pode ser incrementado
        if (!idCarrossel) {
            // pula para a próxima playlist
            this.currentList++;

            // caso a playlist esteja reiniciando
            if (this.totalList <= this.currentList) {
                this.currentList = undefined;
            }

            // caso a playlist esteja iniciando
            if (!this.currentList) {
                this.currentList = 0;
            }

        }

        // troca a playlist sem ter que esperar
        return that.loadPlaylistInTagVideo(ElementVideo, idCarrossel, callback);
    };

    /**
     * Método para verificar se será necessário recriar todos os arquivos de playlist novamente
     * @return {void}
     */
    VideoPlayer.prototype.verifyCreatPlaylist = function __verifyCreatPlaylist()
    {
        // se todos os arquivos já foram baixandos
        // se existe item vencidos na playlist
        if (!this.objectFlags.allFilesExist || this.objectFlags.contentSchedule) {
            this.loadContent();
        }
    };

    /**
     * Método para verificar se o arquivo existe
     *
     * @param  {Function} callback
     * @method contentExists
     * @return {boolean}
     */
    VideoPlayer.prototype.contentExists = function __doneContentExists (listOfList, endCallback)
    {
        var pathFile;
        var that = this;
        var objFileNotExist = [];
        var allFilesExist = true;

        // verifica cada arquivo
        async.each(listOfList, function __doneEachList(listFiles, nexteachFile) {

            async.each(listFiles, function __doneEachFiles(objFile, nextEach) {

                // path do arquivo
                pathFile = that.pathContentPlay + objFile.arquivo;

                // verifica se o arquivo existe
                FileSync.exists(pathFile, function __done(FileExist) {
                    var item = _.clone(objFile);
                    item.exist = true;

                    // caso o arquivo não exista
                    if (!FileExist) {
                        // download do arquivo
                        var downloadItem = {file: objFile.arquivo, type: FileSync.FILE_TYPE_MEDIA, url: null, notify: false, trying: 0, force: true};
                        DownloadCenter.addDownload(downloadItem);

                        // logs
                        // _logError("Vídeo não existe.", objFile);

                        item.exist = false;
                        allFilesExist = false;
                        objFileNotExist.push(item);

                        // next item
                        // return nextEach(false, "Vídeo não existe.", objFile);
                    }

                    // next item
                    nextEach(null);
                });
            }, function __doneEachListFile(result) {
                // callback each
                if (result === undefined) {
                    return nexteachFile(null);
                }

                return nexteachFile(false);
            });
        }, function __doneMap() {

            //////////////
            // callback //
            //////////////
            return endCallback(allFilesExist, objFileNotExist);
        });
    };

    /**
     * Método para verificar se o vídeo é válido
     *
     * @method contentValidExpire
     * @todo É preciso terminar este método
     * @return {boolean}
     */
    VideoPlayer.prototype.contentValidExpire = function __doneContentValidExpire ()
    {
        return true;
    };

    /**
     * Método para redimensionar o vídeo
     *
     * @method resizeVideo
     * @todo Será preciso refatorar este método no futuro
     * @return {void}
     */
    VideoPlayer.prototype.resizeVideo = function __resizeVideo (elementPlayer)
    {
        // call method in main.js
        Player.prototype.resizeVideo(elementPlayer);
    };

    /**
     * Método para poder exibir o vídeo a se utilizado
     * @param  {ElementHtml} elementPlayer
     * @return {void}
     */
    VideoPlayer.prototype.showContainer = function __showContainer (elementPlayer, elementContainer)
    {
        // call method in main.js
        Player.prototype.showContainer(elementPlayer, elementContainer);
    };

    /**
     * Método para exibir conteúdo de vídeo
     *
     * @method showElementPlayer
     * @return {void}
     */
    VideoPlayer.prototype.showElementPlayer = function __showElementPlayer (elementPlayer)
    {
        elementPlayer.style.opacity = 0;
    };

    /**
     * Método para executar o conteúdo
     * @return {void}
     */
    VideoPlayer.prototype.execFn = function __doneExecFn()
    {
        var element = this.getElementPlayer();
        var that = this;
        // item atual da playlist
        var objectCurrent = this.getObjectItem();

        // caso o layout ainda não exista
        if (!element) {
            return false;
        }

        // verifica se o arquivo existe em disco
        if (_.findWhere(this.listFilesNotExists, {"arquivo": this.getObjectItem().arquivo})) {
            this.GAMBFinishVideo = true;
            return this.nextPlaylist(element, function __done() {
                var callb = that.getCallback();
                // chama o póximo conteúdo
                // aguarda 1 segundo para chamar o próximo conteúdo
                if (that.listFilesNotExists.length === that.listFiles.length) {
                    return setTimeout(function() {
                        callb('File not exists', null);
                    }, 2000);
                }

                // callback
                callb('File not exists', null);
            });
        }

        // autoriza que a playlist seja alterada
        // somente nos eventos de troca de conteúdo
        // essa flag deve ser setada
        // TODO: caso seja uma data maior do que 15/07/2016, favor excluir
        // esse bloco de código
        // this.authChangePlayList = true;

        // redimensiona
        this.resizeVideo(element);

        // executa o vídeo
        element.play();

        // exibe o conteiner
        // this.showContainer(this.getElementContainer(), 'video');

        // redimensiona o vídeo
        // this.resizeVideo(element);

        // tempo atual do vídeo
        var currentTime = element.currentTime;

        // media de contenção
        // caso a TV lg não tenha dado o load no vídeo
        // this.timeoutVerifyPlayVideo = setTimeout(function() {

        //     // caso o vídeo ainda não tenha sido carregado o player terá a playlist reiniciada
        //     if (that.flagCountErrorPlay === 5) {
        //         // logs
        //         _log('Ops, vídeo ainda não foi executado. Resetando a playlist.');

        //         playlistManager.resetPlaylistCurrent();

        //         // callback
        //         var callback = that.getCallback();
        //         if (callback) {
        //             callback(null, that.getObjectItem());
        //         }
        //         return;
        //     }

        //     // caso exceda o número máximo de tentativas
        //     // o player deve ser reiniciado
        //     // reinicia a tv
        //     // if (that.flagCountErrorPlay === 10) {
        //     //     // logs
        //     //     _logError("Número máximo de tentativas de iniciar o player excedido. Caracteriza um erro fatal. O Player será reiniciado.");
        //     //     // reinicia a tv
        //     //     // método está no arquivo resetConfiguration.js
        //     //     return shutdownOrRebootPlayer(true);
        //     // }

        //     // acrescenta ao contador
        //     that.flagCountErrorPlay++;

        //     // verifica se é necessário carregar o vídeo de novo
        //     if (element.currentTime === currentTime || element.currentTime === 0) {

        //         _logError("---> VIDEO: medida de contenção, a TV LG não executou o vídeo.");

        //         return that.execFn();
        //     }
        // }, 1000);

        _log("VIDEO PLAY");


        ///////////////////////////////////////////
        // recursos para verificar se a TV da LG //
        // chamou os eventos customizados        //
        ///////////////////////////////////////////

        // quando o vídeo é iniciado
        that.GAMBFinishVideo = false;

        // executar assim que o vídeo acabar
        var time = (parseInt(objectCurrent.tempo) + 8) * 1000;

        this.clearTimeouts();
        // registra timeout para verificar os eventos customizados da tv lg
        this.timeOutFinishVideo = setTimeout(preventionEventError, time);

        function preventionEventError() {
            console.debug("Evento executado no final do vídeo.", time);

            if (!that.GAMBFinishVideo) {
                // OS EVENTOS DO VÍDEO NÃO FORAM CHAMADOS
                console.log("%c -- VIDEO: Eventos customizados do vídeo não foram chamados. O vídeo será executado novamente.", 'background: red; color: white');
                // autoriza que a playlist seja alterada
                that.authChangePlayList = true;

                // será necessário criar outra tag vídeo
                playlistVideo.reloadTagVideo(function() {
                    // caso ocorra algum problema no player
                    // ele pare de tocar os vídeos
                    // o player será reiniciado.

                    // caso fique pronto a playlist irá ser reiniciada
                    playlistManager.resetPlaylistCurrent();
                });

                // volta a toca a playlist
                // window.playNext();
            }
        }

        ///////////////////////////////////////////
        // recursos para verificar se a TV da LG //
        // chamou os eventos customizados        //
        ///////////////////////////////////////////


        // testando o arquivo
        // setTimeout(verifyFinishVideo, 2000);

        /**
         * Método para verificar se o vídeo já acabou
         * TODO: UTILIZAR ESTE MÉTODO PARA CORRIGIR O FLUXO DE VÍDEOS SENDO EXECUTADOS
         */
        // function verifyFinishVideo() {
        //     // verifica todas as listas de arquivos
        //     for (var i in that.fileForPlaylist) {
        //         // se objeto da playlist está na lista atual
        //         if (_.findWhere(that.fileForPlaylist[i], {"arquivo": objectCurrent.arquivo})) {
        //             // caso o arquivo carregado esteja errado
        //             if (parseInt(that.currentList) !== parseInt(i)) {
        //                 console.log("i, that.currentList, objectCurrent");
        //                 console.error("---> ALERT <----", i, that.currentList, objectCurrent);

        //                 _logError("Foi detectado um erro ao exercutaos os vídeos. O player será resetado.");

        //                 // caso fique pronto a playlist irá ser reiniciada
        //                 playlistManager.resetPlaylistCurrent();

        //                 // remove verificação de vídeo
        //                 clearTimeout(this.timeOutFinishVideo);
        //             }
        //         }
        //     }

        // }

        return true;
    };

    /**
     * Método para substituir a tag vídeo
     * @return {void}
     */
    VideoPlayer.prototype.reloadTagVideo = function __reloadTagVideo(callback)
    {
        // será necessário criar outra tag vídeo
        var classLayoutArea = new LayoutArea([]);
        // remove a tag vídeo da área
        this.getElementPlayer().remove();
        // nova tag
        var tagVideo = classLayoutArea.createVideo({});
        this.setElementPlayer(tagVideo);
        this.getElementContainer().appendChild(tagVideo);
        tagVideo = null;

        callback? callback() : null;
    }

    /**
     * Método para verificar se o conteúdo a ser executado é válido
     * @return {[type]} [description]
     */
    VideoPlayer.prototype.contentIsValid = function __doneContentIsValid (callback)
    {
        var that = this;

        this.contentExists(function __done(fileExist) {

            if (!fileExist) {
                return callback(false);
            }

            // elemento para o player é válido
            if (!that.getElementPlayer()) {
                return callback(false);
            }

            // Objeto do item é válido
            if (!(that.getObjectItem() instanceof DataContent)) {
                return callback(false);
            }

            // conteúdo a ser executado não está expiratado
            if (!that.contentValidExpire (that.getObjectItem()))
            {
                return callback(false);
            }


            return callback(true);
        });
    };

    /**
     * Método para ser executado antes do conteúdo ser iniciado
     * @return {void}
     */
    VideoPlayer.prototype.execFnBefore = function __doneExecFnBefore()
    {};

    /**
     * Método para ser executa depois do conteúdo ser iniciado
     * @return {void}
     */
    VideoPlayer.prototype.execFnAfter = function __doneExecFnAfter()
    {};

    /**
     * Método para pegar o elemento que irá tocar o conteúdo
     *
     * @method getElementPlayer
     * @return {ElementHtml}
     */
    VideoPlayer.prototype.getElementPlayer = function __getElementPlayer ()
    {
        return this.elementPlayer;
    };

    /**
     * Método para setar o elemento que irá tocar o conteúdo
     *
     * @method setElementPlayer
     * @param {ElementHtml} elementPlayer
     */
    VideoPlayer.prototype.setElementPlayer = function __setElementPlayer (elementPlayer)
    {
        this.elementPlayer = elementPlayer;
    };

    /**
     * Método para pegar o elemento que represeta a área do template
     *
     * @method getElementContainer
     * @return {ElementHtml}
     */
    VideoPlayer.prototype.getElementContainer = function __getElementContainer ()
    {
        return this.elementContainer;
    };

    /**
     * Método para setar o elemento que representa a área do template
     *
     * @method setElementContainer
     * @param {ElementHtml} elementContainer
     */
    VideoPlayer.prototype.setElementContainer = function __setElementContainer (elementContainer)
    {
        this.elementContainer = elementContainer;
    };

    /**
     * Método para pegar o objeto do conteúdo
     *
     * @method getObjectItem
     * @return {DataContent}
     */
    VideoPlayer.prototype.getObjectItem = function __getObjectItem ()
    {
        return this.objectItem;
    };

    /**
     * Método para setar o o objeto do conteúdo
     *
     * @method setObjectItem
     * @param {Object} objectItem
     */
    VideoPlayer.prototype.setObjectItem = function __setObjectItem (objectItem)
    {
        this.objectItem = objectItem;
    };

    /**
     * Método para pegar a função de callback.
     * Essa função só pode ser invocado uma única vez
     *
     * @method getCallback
     * @return {Function}
     */
    VideoPlayer.prototype.getCallback = function getCallback ()
    {
        var call = this.fnCallback;
        return this.fnCallback = undefined, call;
    };

    /**
     * Método para setar a função de callback
     *
     * @method setCallback
     * @param {Function} fnCallback
     */
    VideoPlayer.prototype.setCallback = function setCallback (fnCallback)
    {
        this.fnCallback = fnCallback;
    };

    /**
     * Método para pegar a função de callback
     *
     * @method getPlaylist
     * @return {Object}
     */
    VideoPlayer.prototype.getPlaylist = function getPlaylist ()
    {
        return this.playlist;
    };

    /**
     * Método para retornar a lista de arquivos a serem executados
     */
    VideoPlayer.prototype.getPlaylistFile = function getPlaylistFile ()
    {
        return this.playlistFiles;
    };

    /**
     * Método para setar a função de callback
     *
     * @method setPlaylist
     * @param {Object} playlist
     */
    VideoPlayer.prototype.setPlaylist = function setPlaylist (loadedFile)
    {
        if(!loadedFile || typeof loadedFile != 'object')
            return;

        if (typeof loadedFile.seq != "undefined") {
            if(typeof(loadedFile.seq) == 'string')
                loadedFile.seq = loadedFile.seq.split(',');

            this.playlist = loadedFile.seq;
        } else if (loadedFile.length) {
            this.playlist = loadedFile;
        }

        this.playlistFiles = loadedFile.itens;
    };


    _global.VideoPlayer = VideoPlayer;

}) (window);
