// Redimensionar a tela e posicionar a tela;
// Entrar em Fullscreen;
// Sair do Fullscreen;

(function() {

    function WebServerScreen(WindowApp) {
        this.WindowApp = WindowApp;
    };

    /**
     * Método para listar todos os métodos do objeto
     * @return {array}  lista de todas as funções disponíveis
     */
    var listFunctions = [
        'fullscreen',
        'exitfullscreen',
        'resize',
        'position',
        'show',
        'hide',
        ];

    WebServerScreen.prototype.callFunction = function (request) {
        // verifica se possue o parâmetro necessário para identificar o conteúdo
        if (!('uri' in request) || !('path' in request)) {
            throw new Error("Object invalid");
        }

        var uri = request.path.split("/");

        // verifica qual é comando a ser executado
        var command = uri[4];

        // console.log('TAG_MAYCON _.indexOf(listFunctions, command)', _.indexOf(listFunctions, command));

        if (_.indexOf(listFunctions, command) === -1) {
            throw new Error("Function not found");
        }

        // verifica quais foram os parâmetos passados
        var params = request.arguments;

        // console.log('TAG_MAYCON WebServerScreen callFunction: command, params', command, params);

        // executa o comando
        command = command.charAt(0).toUpperCase() + command.slice(1);
        this[command](params);
    };

    /**
     * Método para fazer com a tela fique em full screen
     */
    WebServerScreen.prototype.Fullscreen = function () {
        this.WindowApp.fullscreen();
    };

    /**
     * Método para colocar uma janela em foco na tela
     */
    WebServerScreen.prototype.Show = function () {
        // console.log('TAG_MAYCON Commando via Http Focus:');
        this.WindowApp.setAlwaysOnTop(true);
        this.WindowApp.setVisibleOnAllWorkspaces(true);
        this.WindowApp.show(true);
    };

    /**
     * Métodod para esconder a janela
     */
    WebServerScreen.prototype.Hide = function () {
        // console.log('TAG_MAYCON Commando via Http Hide:');
        this.WindowApp.setAlwaysOnTop(false);
        this.WindowApp.setVisibleOnAllWorkspaces(false);
        this.WindowApp.hide();
    };

    /**
     * Método para sair do full screen
     */
    WebServerScreen.prototype.Exitfullscreen = function () {
        this.WindowApp.restore();
    };

    /**
     * Método para redimencionar a tela
     * @param {object} params
     */
    WebServerScreen.prototype.Resize = function (params) {

        // caso não seja enviado nenhum parâmetro
        if (!('width' in params) || !('height' in params)) {
            throw new Error("Parameters not found.");
        }

        var width = params.width;
        var height = params.height;

        this.WindowApp.resizeTo(width, height);
    };

    /**
     * Método para reposicionar a janela
     * @param {object} params
     */
    WebServerScreen.prototype.Position = function (params) {
        // caso não seja enviado nenhum parâmetro
        if (!('top' in params) || !('left' in params)) {
            throw new Error("Parameters not found.");
        }

        var top = params.top;
        var left = params.left;

        this.WindowApp.moveTo(left, top);
    };

    window.WebServerScreen = WebServerScreen;
})(window);
