window.APP_API_URL = 'http://chrome.4yousee.com/api';
//WebApplication
var app;
/**
 * Caso o layout padrão seja alterado
 *
 * @property {boolean} layoutDefaultChange
 */
var layoutDefaultChange;

/**
 * Variável para identificar qual player está sendo tocado
 * @type {Object}
 */
window.typePlayer = window.typePlayer || {
    name: 'chrome'
};

/**
 * Versão do App
 * @type {String}
 */
var versionApp = '0.1.4'

var erroFileNewsLayout = true;;

/**
 * Caso a janela principal esteja como fullscreen
 *
 * @type {Boolean}
 */
var windowFullScreen = true;


/**
 * Array com objetos do player. Formato: [{id: int, url: string}]
 *
 * @property {array} arrayObjctsPlayers
 */
var arrayObjctsPlayers;

/**
 * Variável com o nome da pasta do projeto
 *
 * @property {string} projectName
 */
var projectName;

/**
 * Variável com o hash para acessar a pasta do projeto
 * @property {string} appDir
 */
var appDir;

/**
 * Objeto da pasta do projeto
 * @property {Directory} rootDirEntry
 */
var rootDirEntry;

/**
 * Variável com o host do serviço http
 *
 * @property {String} hostPlayerHttp
 */
// var hostPlayerHttp = 'http://192.168.0.65/4yousee-chrome-player/storage/';
var hostPlayerHttp = 'http://localhost:9080/';

/**
 * Variável para controlar quando está sendo executado algum conteúdo.
 * GAMB: Não consigo no momento encontrar uma forma melhor de se fazer isso.
 * @type {Date}
 */
var controllPlayerContent;

/**
 * Método para inicializar as configurações do projeto
 *
 * @method initConfiguration
 * @return {void}
 */
function initConfiguration (callback) {
    // Configurações que são padrão do projeto
    player4uc.storage.get(['settings.players', 'settings.projectName', 'settings.appDir', 'settings.fullscreen'], function (storageObj) {
        // lista de players
        window.arrayObjctsPlayers = storageObj['settings.players'];
        // pasta raiz do projeto
        window.projectName = FileSync.PROJECT_PREFIX + storageObj['settings.projectName'] || '';
        // pasta de escrita de aplicativos
        window.appDir = storageObj['settings.appDir'];
        // se o player deve estar em fullscree
        window.windowFullScreen = storageObj['settings.fullscreen'];
        // busca a pasta de arquivos do sistema
        window.rootDirEntry = 'file://internal/';

        // callback
        if (typeof callback == 'function') callback();
        // logs
        // console.info("storageObj", storageObj);
    });

    // evento para ser executa a cada x horas
    // ele irá fazer com que assim que o dia for alterado
    // caso o player fique ligado por  mais de 24 horas
    // troque a playlist
    setInterval(function _changeFileMedia() {
        // evento para trocar o arquivo media do dia
        EventLayout.trigger('changeFileMedia', new Date().getDay());
        _log('EVENTO PARA TROCAR O MEDIA EXECUTADO');
    }, 1000 * 60 * 60 * 2); //2h
}

/**
 * Função que começa todo o processo de player
 *
 * @method startupScreen
 * @return {void}
 */
function startupScreen() {
    // Cria a tela de configuração do player
    player4uc.window.create(
        'screens/start-config/startup-screen.html?' + new Date().getTime() , {
            bounds: {
                'width': window.screen.availWidth,
                'height': window.screen.availHeight
            },
            // frame: 'none', // disable window controlls (close, maximize, etc)
            id: 'configWindow',
            // state: 'fullscreen',
        },
        function windowCreated(window) {
            // window.fullscreen();
            _log('windowCreate - startup-screen');
            window.contentWindow.APP_API_URL = APP_API_URL;
            window.contentWindow.startMainWindow = startMainWindow;
        }
    );
}

/**
 * Método para iniciar a janela do player
 *
 * @method startMainWindow
 * @return {void}
 */
function startMainWindow(endCallback) {
    endCallback = (typeof endCallback === 'function'? endCallback : function() {});
    // var winwidth = parseInt(window.screen.availWidth/2);
    // var winheight = parseInt(window.screen.availHeight/2);

    // TODO:
    // ANTES QUE O SISTEMA INICIE TODAS AS JANELAS
    // VERIFICAR QUAIS SÃO OS PLAYERS E SABER SE TODOS OS ARQUIVOS ESTÃO LÁ
    // VERIFICAR SE PLAYER TEM CONDIÇÕES DE INICIAR

    var iterator = 1,
        windowId;

    // iniciando as configurações do sistema
    initConfiguration (function __doneInitConfiguration() {
        // pega informações sobre os monitores antes de abrir as janelas
        // será necessário pesquisar como utilizar o recursos para varios monitóres
        // player4uc.system.display.getInfo(configurationPlayers);
        configurationPlayers([
            {
                workArea: {
                    left: 0,
                    top: 0,
                    width: window.window.innerWidth,
                    height: window.window.innerHeight,
                }
            }
        ]);
    });

    /**
     * Método para realizar a configuração dos players
     * @param  {array} info
     * @return {void}
     */
    function configurationPlayers (info) {
        var players = window.arrayObjctsPlayers;
        var folder = window.projectName;
        var appDir = window.appDir;

        // largura/altura do monitor 0
        // var totalWidth = info[0].workArea.width;
        // var totalHeight = info[0].workArea.height;

        // verifica se tem o segundo monitor
        // var secondMonitor = null;
        // if (info.length > 1) {
        //     secondMonitor = info[1].workArea;
        // }

        // verifica quantas janelas por linha e qual a dimensão cada uma deve ter
        // var wins = players.length - (players.length % 2), // número de janelas no primeiro monitor
        //     perline = wins / 2, // total de janelas por linha
        //     winwidth = parseInt(totalWidth / (perline!=0?perline:1)), // largura de cada janela
        //     winheight = parseInt(totalHeight / 2), // altura de cada janela
        //     winleft =  info[0].workArea.left, // left inicial
        //     wintop = info[0].workArea.top; // top inicial

        // SAMSUNG ONLY
        winwidth =  info[0].workArea.width;
        winheight =  info[0].workArea.height;
        winleft = 0;
        wintop = 0;

        // O player 1 deve ser o padrão
        var listPlayersWindow = [players[0]];

        async.eachSeries(listPlayersWindow, function(playerData, cb){
            var innerBounds = {
                'width': winwidth,
                'height': winheight,
                'left': winleft,
                'top': wintop
            };
            windowId = 'mainWindow-' + iterator;

            // SAMSUNG ONLY - verificar por a janela está aparecendo no meio da tela
            // // recalcula a posição para a próxima janela
            // if (iterator == perline) {
            //     winleft = 0;
            //     wintop = winheight + info[0].workArea.top;
            // } else if (iterator > wins) {
            //     // posiciona a última tela próxima da primeira, se for número ímpar de telas
            //     innerBounds.left = parseInt(winwidth / 2);
            //     innerBounds.top = parseInt(winheight / 2);
            // } else {
            //     // próxima janela começa logo após a anterior
            //     winleft += winwidth;
            // }

            // se a quantidade de telas for ímpar e estamos na última tela
            // jogamos para o outro monitor (se houver).
            // if (players.length > 1 && (players.length % 2 == 1) && (iterator == players.length) && secondMonitor) {
            //     innerBounds = {
            //         'width': secondMonitor.width,
            //         'height': secondMonitor.height,
            //         'left': secondMonitor.left,
            //         'top': secondMonitor.top
            //     };
            // }

            iterator++;

            // define qual é a orientação da janela
            window.OrientationPlayer = playerData.windowOrientationPlayer;


            /**
             * Abre as janelas dos players
             */
            player4uc.window.create(
                'screens/window.html', {
                    bounds: {
                        'width': window.screen.availWidth,
                        'height': window.screen.availHeight
                    },
                    id: windowId,
                },
                function (appWindow) {
                    // dados do player
                    appWindow.contentWindow.playerData = playerData;

                    // orientação do player
                    appWindow.contentWindow.OrientationPlayer = window.OrientationPlayer;

                    // Evento onload
                    appWindow.contentWindow.addEventListener('load', function() {
                        // starts the loop only after the html content was fully loaded
                        startSyncingFiles(appWindow, playerData, folder, appDir);

                        appWindow.contentWindow.startupScreen = startupScreen;

                        // Ao chegar aqui o chrome ainda não construiu a janela.
                        // classe de layout
                        appWindow.contentWindow.ClassLayout = new ClassLayout(
                            appWindow.contentWindow.document.getElementById('container') // <-- objeto container
                        );
                    });

                    // configura o appEnLight para o player
                    AppEnlight.setRequestInfo({
                        "server": playerData.url,
                        "username": playerData.id,
                        'user_agent': navigator.userAgent
                      // request_id:"server_generated_uuid"
                    });

                    // reajusta a orientação da tela
                    player4uc.window.orientation($(appWindow), window.OrientationPlayer);


                    // class áudio
                    // appWindow.contentWindow.ClassAudio = new ClassAudio(
                    //     appWindow.contentWindow.document.getElementById('container-audio'), // <-- objeto container
                    //     playerData
                    // );

                    // play no áudio
                    // applyAudioWindow(appWindow, playerData, true);

                    // Alterando a variável
                    appWindow.contentWindow.firstLayout = true;

                    // função de callback
                    cb();
                }
            );

        }, function __doneEachSeriesPlayers(err){
            // callback
            endCallback();
        });
    }

}

// class para tocar o conteudo rss
var classRssPlayerLayout = [];

/**
 * Método para adicionar em cada janela a sua lista de áudios
 *
 * @method applyAudioWindow
 * @param  {Window} appWindow
 * @param  {Object} playerData
 * @return {void}
 */
function applyAudioWindow (appWindow, playerData, resetAudio) {
    var that = this;
    var projPath;

    // verifica se o player está pronto para tocar
    // appWindow.contentWindow.ClassAudio.validateConstruction(true, function() {
    //     console.log("TAG_MAYCON applyAudioWindow Áudios prontos para tocarem.");
    // });

    return;

    // Busca json da playlist de áudio
    player4uc.storage.get(['settings.appDir', 'settings.projectName'], function(storageObj) {

        projPath = FileSync.PROJECT_PREFIX + storageObj['settings.projectName'];
        var pathFile = projPath + '/' + FileSync.PLAYER_DIR_JSON + '/media.' + playerData.id + '.a0.json';

        // busca os arquivos na pasta de dados
        player4uc.fileSystem.restoreEntry(storageObj['settings.appDir'], function appDirRestored(appDir) {

            // busca a playlist de áudio
            FileSync.readJSONFile(appDir, pathFile, function(jsonItem, error) {

                // caso não exista nenhum arquivo
                if (!(_.isNull(error))) {
                    return _logError("applyAudioWindow: error", error);
                }

                // caso não venha no formato de JSON
                if (_.isString(jsonItem)) {
                    jsonItem = JSON.parse(jsonItem);
                }

                // seta a playlist
                appWindow.contentWindow.ClassAudio.setjsonPlaylist(jsonItem);

                // toca a lista
                appWindow.contentWindow.ClassAudio.init(resetAudio);
                // console.log("TAG_MAYCON applyAudioWindow");
            });
        });
    });
}

/**
 * Método para montar o layout inicial
 *
 * @method applyLayoutWindow
 * @param  {Element} appWindow  Api da janela aberta
 * @param  {Play} playerData Classe Play
 * @return {void}
 */
function applyLayoutWindow (appWindow, playerData, idLayout, endCallback, forceChangeLayout) {

    var that = this;

    // Busca json do layout
    var pathFile = window.projectName + '/' + FileSync.PLAYER_DIR_JSON + '/layout.' + playerData.id + '.json';

    // busca os arquivos na pasta de dados
    FileSync.readJSONFile(window.rootDirEntry, pathFile, createLayout);

    /**
     * Método para montar o layout na janela
     * @param  {Json} layoutJson Json dos layouts
     * @param  {string|null} error      Caso ocorra algum erro
     * @return {void}
     */
    function createLayout (layoutJson, error) {

        if (!_.isNull(error) || _.isNull(layoutJson)) {
            _logError(error);
            return endCallback();
        }

        var classLayout = appWindow.contentWindow.ClassLayout

        // id do layout para aplicar
        var layoutId = classLayout.getIdLayout() || layoutJson.layouts.default;

        // caso seja informado um valor boleano verdadeiro será carregado o layout padrão
        // TODO: ISSO É UMA GAMB, PRECISA SER REVISTA E PENSAR EM UMA ALTERNATIVA
        if (typeof idLayout === 'boolean') {

            // caso a playlist principal tenha algum layout, o layout padrão não deve
            // ser carregado
            if (layoutDefaultChange === undefined) {
                layoutId = layoutJson.layouts.default;
            }

        } else if(_.isNumber(idLayout) || _.isString(idLayout)) {
            // caso seja informado algum layout
            layoutId = idLayout;
        }


        // caso o layout ainda não tenha sido aplicado
        if (classLayout.getIdLayout() !== layoutId+"" || forceChangeLayout) {

            // reseta o layout
            classLayout.resetLayout(!appWindow.contentWindow.firstLayout);

            // seta o arquivo de layout do cliente
            classLayout.setJsonAllLayout(layoutJson);

            // seleciona o layout informado ou o principal
            classLayout.setLayout(layoutId);

            // monta o layout
            classLayout.createLayout(undefined, !appWindow.contentWindow.firstLayout);

            // Os conteúdos estarem do tamanho da área do layout ao
            // executar o conteúdo
            var allArea = classLayout.getAreasAux() || [];
            allArea.push(classLayout.getAreaMain());
            resizeAll(
                allArea
            );

            // player nos templates
            playerContentAreas(classLayout);
        }

        // variável para controlar a primeira troca de layout
        appWindow.contentWindow.firstLayout = false;


        // limite para função de callback
        // as outras funções são recursivas
        return endCallback();
    }

    /**
     * Método para rodar o conteudo nas áreas auxiliares
     * esse método faz com que somente conteudo HTML5 seja executado no conteudo
     * @return {void}
     */
    function playerContentAreas (classLayout) {
        // buscar todas as áreas auxiliares
        var arrayAreasAux = classLayout.getAreasAux();
        var i, mediaFile, time = 25;
        var path = window.projectName + '/layout/xml/';

        // pausa todos os conteúdos do layout
        _.each(classRssPlayerLayout, function(classRssPlayer) {
            classRssPlayer.clearTimeout();
        });

        // cria conteúdo para nova área
        for (i in arrayAreasAux) {

            // class para Player no conteúdo
            classRssPlayerLayout[i] = contructAreaLayout(appWindow, arrayAreasAux[i], time, path, classRssPlayerLayout[i]);

            // id do player
            classRssPlayerLayout[i].setIdPlayer(playerData.id);

            // iniciar o conteúdo
            (function (key) {
                setTimeout(function() {

                    // player no conteúdo
                    playerContentRssLayout(key, appWindow);
                }, 500);
            }) (i);
        }
    }
}

/**
 * Tocar a lista de notícias
 * @param  {integer} key Chave da posição da área
 * @return {void}
 */
function playerContentRssLayout(key, appWindow) {
    classRssPlayerLayout[key].play(function(msg, file, keyArea){
        // TODO:
        //  - Avisar o socket
         // console.log("TAG_MAYCON playerContentRssLayout: VOLTEI", new Date());

         // em caso de error
         if (_.isString(msg) && _.isUndefined(file)) {

            // logs
            // console.log("TAG_MAYCON Notícia da barra do layout: não foi possível tocar.", msg);
            // espera um pouco para refaz todo o processo de construção do layout
            setTimeout(function() {

                // class layout
                var classLayout = appWindow.contentWindow.ClassLayout;

                // faz com o conteudo nas áreas sejam tocados
                playerContentAreas(classLayout);
            }, 5000);
            return;
         }
    }, key);
}

/**
 * Método para construir a classe responsável pela área do layout
 *
 * TODO: ESSE MÉTODO NÃO DEVE FICAR AQUI
 * @param  {Object} appWindow
 * @param  {ObjectHtml} arrayAreasAux
 * @param  {integer} time
 * @param  {string} path
 * @param  {undefined|HtmlPlayerArea} classRssPlayerLayout
 * @return {HtmlPlayerArea}
 */
function contructAreaLayout(appWindow, arrayAreasAux, time, path, classRssPlayerLayout) {
    // caso ainda não tenha sido definido
    if (_.isUndefined(classRssPlayerLayout)) {
        // class para Player no conteúdo
        classRssPlayerLayout = new HtmlPlayerArea(appWindow, new Rss(window.projectName, false), arrayAreasAux.getElementHtml(), time, path);
    }

    // seta o novo container
    classRssPlayerLayout.setContainer(arrayAreasAux.getElementHtml());

    // setando a fonte
    classRssPlayerLayout.setTemplate(arrayAreasAux.getTemplate());

    // caminho do arquivo
    var mediaFile = 'rss.' + arrayAreasAux.getFonte() + '.xml'

    // seta o arquivo de playlist
    classRssPlayerLayout.setPlayList(mediaFile);

    // gamb para esperar o chrome ler o arquivo de playlist
    // cancela a instancia anterior
    classRssPlayerLayout.clearTimeout();

    return classRssPlayerLayout;
}

/////////////////////////////////////////
// fica monitorando a troca de notícia //
/////////////////////////////////////////
addEventListener('message', function(e) {
    var obj = e.data;
    var keyArea = parseInt(obj.data.keyArea);
    var idWindow = obj.data.idWindow;
    var windowApp = player4uc.window.get(idWindow);

    // verifica se aconteceu algum problema com o template
    // LEGENDA:
    // 1 - Recarregar o layout
    if (obj.error == 1) {
        // logs
        _logError({
            'Error Layout ID': idWindow,
            'obj': obj,
        });

        // caso o problema tenha sido na área principal
        if (obj.data.main) {

            // em caso de erros o conteúdo deve ser trocado.
            controllPlayerContent = undefined;

            // próximo conteúdo
            nextContentMain();

            return;
        }

        // flag para evitar que todo o layout seja reiniciados
        erroFileNewsLayout = false;

        // processa o arquivo de layout novamente
        var filePlayer = FileSyncLayoutTemplate.getNameFile(windowApp.player.id);
        sync.processFileTemplate([filePlayer], function() {

            // reseta o somente á area
            EventLayout.trigger('loadTemplate', keyArea);
        });

        clearInterval(classRssPlayerLayout[keyArea].Timeout[keyArea]);
        classRssPlayerLayout[keyArea].Timeout[keyArea] = undefined;

        return;
    }

    // caso seja área principal
    if (obj.data.main) {

        if (obj.status) {
            // próximo conteúdo
            nextContentMain();
        }

        return;
    }

    // caso seja as áreas auxiliares do layout
    if (obj.status && classRssPlayerLayout[keyArea].Timeout[keyArea] != undefined) {

        // para a função para monitorar a notícia
        clearInterval(classRssPlayerLayout[keyArea].Timeout[keyArea]);
        classRssPlayerLayout[keyArea].Timeout[keyArea] = undefined;
        // console.log("TAG_MAYCON message: event", e);

        // callback
        // playerContentRssLayout(keyArea);
        classRssPlayerLayout[keyArea].play(function (){}, keyArea);
    }

    /**
     * Método para buscar o próximo conteúdo da área principal
     * @return {void}
     */
    function nextContentMain() {
        var arquivo = obj.data.file;
        var tipo = obj.data.type;

        var contentWindowApp = windowApp.contentWindow;

        // caso essa função já tenha sido chamada
        // e nenhum conteúdo html está sendo tocado ele para a função
        if (contentWindowApp.HtmlTimeOut == undefined) {
            return;
        }

        var a = new Date();
        var datePlay = a.getHours() + ":" + a.getMinutes() + ":" + a.getSeconds();

        // log
        _log({
            'text': 'Conteúdo HTML trocado',
            'item': obj,
            'datePlay': datePlay
        });

        // TODO: MUDAR ESSE BLOCO PARA UMA FUNÇÃO
        // notícia
        clearInterval(contentWindowApp.RssPlayerTimeoutRssPlayer);
        contentWindowApp.RssPlayerTimeoutRssPlayer = undefined;
        // conteúdo html
        clearInterval(contentWindowApp.HtmlTimeOut);
        contentWindowApp.HtmlTimeOut = undefined;

        // envia os logs para o manager
        managerConnect.log.save('playlog', arquivo, tipo);

        // busca o próximo item
        var next = windowApp.playlistManager.getNext(true);
        var item = windowApp.playlistManager.getPlaylistItem(next);

        // play na playlist principal
        windowApp.haveAItem_function(item);
    }
});

////////////////
// fim evento //
////////////////

/**
 * Método para poder executar o próximo conteúdo
 *
 * @method playNext
 */
var playNext;


/**
 * Método para fazer com que na área principal execute a playlist
 *
 * @method startMainLoop
 * @param  {Element} appWindow       [description]
 * @param  {PlaylisManager} playlistManager [description]
 * @param  {ManagerConnect} managerConnect  [description]
 * @param  {Object} playerData      [description]
 * @param  {string} folder          [description]
 * @param  {string} appDir          [description]
 * @return {void}                 [description]
 */
function startMainLoop(appWindow, playlistManager, managerConnect, playerData, folder, appDir, preventUpdate) {
    // get the playlist

    var next, loopcnt = 0, item = false;
    var player = appWindow.player;

    /**
     * Função recursiva para rodar o conteudo
     * @return {void}
     */
    playNext = function() {
        var that = this;
        loopcnt = 0, item = null;


        appWindow.haveAItem_function = function  (item){
            if(!item || ((!'arquivo' in item) || item.arquivo == "") && item.tipo != 'n') {
                // throw new Error(player4uc.i18n.getMessage("cantLoadPlaylist") + ' - File not found');
                return playNext();
            }

            // caso seja para trocar o layout
            if (item.tipo === 'l') {
                // troca layout
                _log('Trocando o layout', item.arquivo);

                // flag
                layoutDefaultChange = true;

                // troca o layout
                return EventLayout.trigger('loadLayout', [appWindow, item.arquivo, playNext]);
            }

            // verifica se ainda existe conteúdo tocando
            // ESSA FOI A MAIOR GAMB ESCRITA PARA ESSE APP. MAS FUNCIONA QUE UMA BELEZA SÓ.
            if (typeof controllPlayerContent !== 'undefined' && (new Date() - controllPlayerContent)/1000 < 5) {

                _logError({
                    'message': 'Tentativa de iniciar outro conteúdo.',
                    'Data': controllPlayerContent,
                    'Atual': new Date()
                });

                return;
            }
            // seta nova data
            controllPlayerContent = new Date();

            // limpa todos os callbacks
            player.clearTimeOutPlayer();

            // plays the content
            var fileExt = item.arquivo.split('.').pop();
            var type = player.getTypeMapping(fileExt, item.tipo);

            player.play(type, item, function(error, arquivo){

                // caso não haja errors
                if(!error) {
                    // tratando os dados para manager
                    // caso o tipo for 'car' de carrocel ele deverá ser enviado para o manager como 'i' de institucional
                    var tipo = item.tipo;
                    if (tipo == 'car') {
                        tipo = 'i';
                    }

                    // envia os logs para o manager
                    managerConnect.log.save('playlog', arquivo, tipo);
                } else {
                    controllPlayerContent = undefined;
                }

                // proximo item
                playNext();
            });
        }

        next = playlistManager.getNext(preventUpdate);
        item = playlistManager.getPlaylistItem(next);

        if(item){

            appWindow.haveAItem_function(item);
        } else {

            appWindow.haveAItem_interval = setInterval(function(){
                next = playlistManager.getNext(preventUpdate);
                item = playlistManager.getPlaylistItem(next);

                if(item){
                    clearInterval(appWindow.haveAItem_interval);
                    appWindow.haveAItem_function();
                }

                // caso não encontre nenhum item, tenta carregar os arquivo novamente
                playlistManager.loadFiles();

            }, 10000);
        }


        if (appWindow.contentWindow.firstLayout) {
            // carrega layout
            EventLayout.trigger('loadLayout', [appWindow, undefined, undefined, true]);
        }

    };

    if (typeof appWindow.player == "undefined") {

        // id da janela
        appWindow.contentWindow.id = appWindow.id;

        // instanciando a classe player
        player = new Player(window.projectName, appWindow.contentWindow, playerData.url, playerData.id);
        appWindow.player = player;

        delete player;

        // aguardando até o chrome está preparado, para iniciar o player
        setTimeout(playNext, 5000);
    } else {
        playNext();
    }
}

function showFatalError(msg) {
    player4uc.window.get('mainWindow').contentWindow.container.style.display = 'none';
    player4uc.window.get('mainWindow').contentWindow.loading.style.display = 'none';
    player4uc.window.get('mainWindow').contentWindow.errorMsg.style.display = '';
}

var screenShot, managerConnect;

function startSyncingFiles(appWindow, playerData, folder, appDir) {
    var playlistManager, sync, handlers;

    // pasta do projeto
    folder = window.projectName;

    /**
     * Gerenciador da playlist do player
     * @type {PlayListManager}
     */
    playlistManager = new PlayListManager(playerData.id, playerData.url);
    appWindow.playlistManager = playlistManager;
    appWindow.contentWindow.playlistManager = playlistManager;

    // classe para controlar o socket
    managerConnect = new ManagerConnect(playerData.id, playerData.url);
    managerConnect.listenUpdateCb = function(data){
        // console.log("TAG_MAYCON listenUpdateCb: data", data);

        if(data.fileType == 'list') {
            _log('Sync Started by manager');
            window.sync.init(true, appWindow);
        }
    }

    // Registra a classe que cuida dos arquivos utilizados pelo player
    sync = new HttpFileSync(folder, playerData, playlistManager, managerConnect, false, appWindow);
    window.sync = sync;

    ////////////////
    // ScreenShot //
    ////////////////
    screenShot = new ClassScreenShot(managerConnect.socket);

    // iniciar a classe de download center
    window.downloadCenter = new DownloadCenter(playerData.url, folder, rootDirEntry, managerConnect);

    appWindow.contentWindow.$ = appWindow.contentWindow._$ = window._$ = $;
    appWindow.contentWindow._ = appWindow.contentWindow.__ = window.__ = _;
    appWindow.contentWindow.async = appWindow.contentWindow._async = window._async = async;

    setTimeout(function() {
        // começa a tocar o conteúdo
        startMainLoop(appWindow, playlistManager, managerConnect, playerData, folder, appDir, true);

        // inicia a download
        initDownloadPlayers()
    }, 1000);
}

/**
 * Método para baixar os arquivos do player
 * @param  {Object} playerData Objeto do player que deseja baixar os conteúdos
 * @return {void}
 */
function multiPlayersTvLg(playerData) {

    var _managerConnect = new window.parent.ManagerConnect(playerData.id, playerData.url);
    var _folder = window.projectName;

    // passa em player por player
    // checkProject
    new window.parent.HttpFileSync(_folder, playerData, undefined, _managerConnect, undefined, undefined, true);
}

/**
 * Método para iniciar o download dos arquivos de outros players
 * @param  {Object} players
 * @return {void}
 */
function downloadContentAnotherPlayers(players) {
    async.each(players, function(playerData, endCallBack){
        // baixa conteúdos
        multiPlayersTvLg(playerData);

        // próximo player
        endCallBack();
    });
}

/**
 * Método para alterar a playlist a ser utilizada pelo player
 * @param  {Object} playerData
 * @return {void}
 */
function changePlaylistPlayer(playerData) {

    var windowIframe = player4uc.window.current();
    var classPlayer = windowIframe.player;
    var classPlaylistManager = windowIframe.playlistManager;

    // classe que deverão ser trocadas

    // ManagerConnect
    managerConnect.setPlayerId(playerData.id);
    managerConnect.setEnv4YouSee(playerData.url);

    // HttpFileSync
    sync.setObjectPlayer(playerData);
    sync.setNameFiles(playerData);

    // Player
    classPlayer.setPlayerId(playerData.id);

    // FileSync
    FileSync.setPlayer(playerData);

    // PlayListManager
    classPlaylistManager.setPlayerId(playerData.id);
    classPlaylistManager.setPlayerUrl(playerData.url);

    EventLayout.trigger('changeFileMedia');

    // escode todos as janelas
    // TODO:  NÃO GOSTEI DISSO, DEVE SER REFATORADO
    windowIframe.contentWindow.openSelectsPlayers('hide');
    windowIframe.contentWindow.toggleMenu('hide');
}

/**
 * Método para iniciar download dos arquivos de outros players
 * @return {void}
 */
function initDownloadPlayers() {
    setTimeout(function() {
        // baixa conteúdo dos demais players
        var players = arrayObjctsPlayers.slice(1);
        downloadContentAnotherPlayers(players);
    }, 10000);
}
