"use strict";

(function () {
	if (typeof gapi === 'undefined')
		throw new Error('gapi is undefined.');

	gapi.client.drive = {
		files: {},
		children: {},
		about: {}
	};

	gapi.client.drive.files.list = function(params, callback) {
		gapi.client.request({
			path: "/drive/v2/files",
			params: params,
			callback: function(json, text) {
				if (callback)
					callback(json, text);
			}
		});
	};

	gapi.client.drive.files.get = function(fileId, params, callback) {
		gapi.client.request({
			path: "/drive/v2/files/" + fileId,
			params: params,
			callback: function(json, text) {
				if (callback)
					callback(json, text);
			}
		});
	};

	gapi.client.drive.files.download = function(fileMetadata, callback) {
		var parts = fileMetadata.downloadUrl.split('/');
		gapi.client.request({
			root: parts[0] + "//" + parts[2],
			path: "/" + parts.slice(3).join("/"),
			binary: true,
			callback: function(json, rawResp) {
				if (callback)
					callback(json, rawResp);
			}
		});
	};

	gapi.client.drive.children.list = function(folderId, params, callback) {
		gapi.client.request({
			path: "/drive/v2/files/" + folderId + "/children",
			params: params,
			callback: function(json, text) {
				if (callback)
					callback(json, text);
			}
		});
	};
})();
