var timeOutMenu0 = undefined;

var _shutdownOrRebootPlayer = window.parent.shutdownOrRebootPlayer;

$(document).ready(function() {


    // fecha o player
    $(document).on('click', "#closePlayer", function(evt) {
        _shutdownOrRebootPlayer();
    });

    // resetar as configurações
    $(document).on('click', "#resetConfiguration", function(evt) {
        resetConfiguration();
    });

    // resetar as configurações
    $(document).on('click', "#modal_confirm_reset", function(evt) {
        jQuery(player4uc.window.current().contentDocument.getElementById("modal_reset")).modal('show');
    });


    // troca a orientação da tela
    $(document).on('click', "#changeOrientation", function(evt) {
        changeOrientation();
    });


    // troca a orientação da tela
    $(document).on('click', ".close_modal", function(evt) {

        // fecha o modal
        $(this).parents('.modal').modal('hide');

    });



    // evento modal
    jQuery(document).on('hidden.bs.modal', '#modal', function () {

    });

    /**
     * Evento para ser executa assim que o modal for carregado
     *
     * @event show.bs.modal
     * @element #modal
     * @return {void}
     */
    jQuery(document).on('show.bs.modal', '#modal', function () {
    	// toggleMenu('show');
    });

    /**
     * Evento para controlar os botões do controle remoto
     * @return {void}
     */
    jQuery(window.parent).keydown(function(inEvent){
        var keycode;

        if(window.event) {
            keycode = inEvent.keyCode;
        } else if(inEvent.which) {
            keycode = inEvent.which;
        }
        // _log('window ----------', keycode);

        var iframePlayer = jQuery(player4uc.window.current()).contents();

        // KEY 1
        switch(keycode) {
            case 49: // tecla 1
                resetConfiguration();
                break;

            case 50:  // tecla 2
                changeOrientation();
                break;

            case 51:  // tecla 3
                _shutdownOrRebootPlayer();
                break;

            case 52: // tecla 4
                iframePlayer.find("#link_modal_info").click();
                break;

            case 48: // tecla 0
                iframePlayer.find("#container").click();
                break;

            // case 52:  // tecla 4
            //     iframePlayer.find("#link_modal_players").click();
            // break;

            default:
                accessKeyControl(keycode);
        }

        window.parent.focus();
    });

    /**
     * Evento para controlar o menu do topo
     * @return {void}
     */
    jQuery(document).on('click','#container', function(evt) {

        // modal está aberto
        if (jQuery("#modal").css('display') !== 'block') {
            return toggleMenu('show');
        }

        // escode o menu
        toggleMenu('hide');
        // escode o modal de informações
        toggleInfo('hide');

        // foca a janela principal
        window.parent.focus();
    });

    /**
     * Evento para controlar o menu de informações
     * @return {void}
     */
    jQuery(document).on('click','#link_modal_info', function(evt) {

        // modal está aberto
        if (jQuery("#modal_info").css('display') !== 'block') {
            return toggleInfo('show');
        }

        // escode o menu
        toggleInfo('hide');

        // foca a janela principal
        window.parent.focus();
    });

    /**
     * Evento para controlar a lista de players
     * @return {void}
     */
    jQuery(document).on('click','#link_modal_players', function(evt) {

        // modal está aberto
        if (jQuery("#modal_players").css('display') !== 'block') {
            return openSelectsPlayers('show');
        }

        // escode o menu
        openSelectsPlayers('hide');

        // remove todos os eventos
        var optionsKey = [53, 54, 55, 56, 57, 52];
        for (var i in optionsKey) {
            jQuery(document).off('KEY_CODE' + optionsKey[i], registerEventControl);
        }

        // foca a janela principal
        window.parent.focus();
    });
});

/////////////
// funções //
/////////////

/**
 * Método para executa eventos registrados para tecla
 * @param  {integer} keycode
 * @return {void}
 */
function accessKeyControl(keycode) {
    jQuery(document).trigger('KEY_CODE' + keycode);
}

/**
 * Método para registrar evento para controle
 * @return {void}
 */
function registerEventControl () {
    window.parent.changePlaylistPlayer(this);
}


/**
 * Método para exibir modal com lista de players
 * @param  {string} status
 * @return {void}
 */
function openSelectsPlayers(status) {
    toggleWindow("#modal_players", 'partial/select-players.html?', status);
}


/**
 * Método para tratar o comportamento do menu superior
 *
 * @method toggleMenu
 * @return {void}
 */
function toggleMenu(status) {
    toggleWindow("#modal", 'partial/dialog-config.html?', status);
}

/**
 * Método para tratar o comportamento da janela de menu
 *
 * @method toggleInfo
 * @param  {string} status
 * @return {void}
 */
function toggleInfo(status) {
    toggleWindow("#modal_info", 'partial/info.html?', status);
}

/**
 * Método para fechar todos os modals
 *
 * @method claseAllModal
 * @return {void}
 */
function closeAllModal() {
    openSelectsPlayers("hide");
    toggleMenu("hide");
    toggleInfo("hide");
}

/**
 * Método para fazer aparecer e esconder janela de modal
 * @param  {string} modal
 * @param  {string} url
 * @param  {string} status
 * @return {void}
 */
function toggleWindow (modal, url, status) {
    var menu = jQuery(modal);
    if (status === 'show') {
        menu.modal({
            "remote": url + new Date().getTime()
        });

        // inicia o timeout para fechar a janela
        clearTimeout(timeOutMenu0);
        timeOutMenu0 = setTimeout(function() { closeAllModal() }, 15 * 1000);

        return;
    }

    // escode a janela
    menu.modal('hide');
}

/**
 * Método para resetar as configurações do player
 * @return {void}
 */
function resetConfiguration() {
    // remover as configurações
    window.localStorage.clear();

    // excluir todos os arquivos
    player4uc.filesystem.rmdir(window.parent.projectName, {"recursive": true});

    // reajusta a orientação da tela
    player4uc.window.orientation(player4uc.window.current(), 0);

    // reseta tv
    _shutdownOrRebootPlayer(true);
}

/**
 * Método para trocar a orientação
 * @return {void}
 */
function changeOrientation() {
    var winPlayer = player4uc.window.get('mainWindow-1').contentWindow;

    // Define a orientação desejada
    if (!winPlayer.OrientationPlayer) {
        winPlayer.OrientationPlayer = 1;
    } else {
        winPlayer.OrientationPlayer = 0;
    }

    // seta a definição no local storage
    var playerData = winPlayer.playerData;
    playerData.windowOrientationPlayer = winPlayer.OrientationPlayer;
    player4uc.storage.set({'settings.players': [playerData]});

    window.parent.OrientationPlayer = winPlayer.OrientationPlayer;
    window.OrientationPlayer = winPlayer.OrientationPlayer;

    // reajusta a orientação da tela
    player4uc.window.orientation(player4uc.window.current(), winPlayer.OrientationPlayer);
}
