jQuery(window.parent).keydown(function(inEvent){
    if(window.event) {
        keycode = inEvent.keyCode;
    } else if(inEvent.which) {
        keycode = inEvent.which;
    }


    // console.debug('APERTOU AQUI');

    // KEY 1
    switch(keycode) {
        case 405: //BOTÃO AMARELO
            configurationTV(3);
            break;

        case 406: // BOTÃO AZUL
            configurationTV(2);
            break;
    }
});

function configurationTV(action) {

    // if (confirm("Password:") !== "4youseeplayer") {
    //     return;
    // }

    switch (action) {
        case 1:
            setServerPropertyRemote();
            break;
        case 2:
            setServerPropertyLocal("http://192.168.0.42/lg/app4yousee.zip", 'zip', true);
            break;
        case 3:
            setServerPropertyLocal("http://files.4yousee.com.br/players/dev/webos.zip", 'zip');
            break;
        case 4:
            setServerPropertyLocal("http://192.168.0.42/lg/app4yousee.ipk", 'ipk');
            break;
    }

    // JavaScript code
    function setServerPropertyRemote () {
        var options = {};
        options.serverIp = "192.168.0.42";
        options.serverPort = 80;
        options.secureConnection = true;
        options.appLaunchMode = Configuration.AppMode.REMOTE;
        options.fqdnMode = true;
        options.fqdnAddr = "http://192.168.0.42/lg/4YouseePlayer/app/";

        function successCb() {
            // console.debug("CONFIGURAÇÕES PARA O PLAYER REMOTO: " + options.fqdnAddr);

            // reseta o player
            shutdownOrRebootPlayer(true);
        }

        function failureCb(cbObject) {
            var errorCode = cbObject.errorCode;
            var errorText = cbObject.errorText;

            // console.debug ("Error Code [" + errorCode + "]: " + errorText);
        }

        var configuration = new Configuration();
        configuration.setServerProperty(successCb, failureCb, options);
    }
}

// JavaScript code
function setServerPropertyLocal (fqdnAddr, type, restart) {
    var options = {};
    options.serverIp = "0.0.0.0";
    options.serverPort = 80;
    options.secureConnection = true;
    options.appLaunchMode = Configuration.AppMode.LOCAL;
    options.appType = type;
    options.fqdnMode = true;
    options.fqdnAddr = fqdnAddr;

    function successCb() {
        // console.debug("CONFIGURAÇÕES PARA O PLAYER LOCAL: " + options.fqdnAddr);

        ////////////////////
        // ATUALIZA O APP //
        ////////////////////
        var options_ = {};
        options_.to = Storage.AppMode.LOCAL;
        options_.recovery = true;
        options_.type = type;

        var successCb = function (){
            console.debug("Application Update successful");
            if (restart) {
                // reseta o player
                shutdownOrRebootPlayer(true);
            }
        };

        var failureCb = function (cbObject){
            var errorCode = cbObject.errorCode;
            var errorText = cbObject.errorText;

            console.debug( " Error Code [" + errorCode + "]: " + errorText);
        };

        storage = new Storage();
        storage.upgradeApplication(successCb, failureCb, options_);
    }

    function failureCb(cbObject) {
        var errorCode = cbObject.errorCode;
        var errorText = cbObject.errorText;

        console.debug ("Error Code [" + errorCode + "]: " + errorText);
    }

    var configuration = new Configuration();
    configuration.setServerProperty(successCb, failureCb, options);
}

/**
 * Método para fechar o player
 * @return {void}
 */
function shutdownOrRebootPlayer (shutdown) {
    // fecha o player
    var options = {};
    options.powerCommand = Power.PowerCommand.REBOOT;
    if (!shutdown) {
        options.powerCommand = Power.PowerCommand.SHUTDOWN;
    }

    function successCb() {
        _log("OK, Tv sendo desligada");
    }

    function failureCb(cbObject) {
        var errorCode = cbObject.errorCode;
        var errorText = cbObject.errorText;

        _log ("Error Code [" + errorCode + "]: " + errorText);
    }

    var power = new Power();
    power.executePowerCommand(successCb, failureCb, options);
}



/**
 * Método para verificar se a atualização disponível é válida
 * @param  {XMLDom}   xmlConfig
 * @param  {Function} callback
 */
function verifyUpdate(xmlConfig, callback)
{
    getPlatformInfo(function __done(configs) {
        // caso tenha ocorrido algum error
        if (!configs || 'errorCode' in configs) {
            return callback(false);
        }

        // verifica a versão do WebOS
        if ('modelName' in configs) {
            var model = configs.modelName.replace("WEBOS", '');
            var modelNew = xmlConfig.querySelector("webos").textContent;

            if (parseInt(model) > parseInt(modelNew)) {
                _log("WebOS not compatible.");
                return callback(false);
            }
        }

        // verifica a versão firmware
        if ('firmwareVersion' in configs) {
            var version = configs.firmwareVersion.replace(/\.+/g,"");
            var versionNew = xmlConfig.querySelector("firmwareVersion").textContent.replace(/\.+/g,"");

            if (parseInt(version) > parseInt(versionNew)) {
                _log("Firmware not compatible.");
                return callback(false);
            }
        }

        // verificar a versão do APP
        // if ('version' in configs) {
            var version = window.versionApp.replace(/\.+/g,"");
            var versionNew = xmlConfig.querySelector("version").textContent.replace(/\.+/g,"");

            if (parseInt(version) > parseInt(versionNew)) {
                _log("Version player not compatible.");
                return callback(false);
            }
        // }

        callback(true);
    });
}

function getPlatformInfo (callback) {
    function successCb(cbObject) {
        callback(cbObject);
        // {
        //     "modelName":"WEBOS2",
        //     "serialNumber":"SKJY1107",
        //     "firmwareVersion":"03.71.10",
        //     "hardwareVersion":"1",
        //     "sdkVersion":"1.3.22102",
        //     "manufacturer":"LGE"
        // }
    }

    function failureCb(cbObject) {
        callback(cbObject);

        var errorCode = cbObject.errorCode;
        var errorText = cbObject.errorText;

        console.log ("Error Code [" + errorCode + "]: " + errorText);
    }

    var deviceInfo = new DeviceInfo();
    deviceInfo.getPlatformInfo(successCb, failureCb);
}
