(function(_global) {
    'use strict';
    /**
     * Class to unzip files
     *
     * @class Unzipper
     * @param {Object}   options  [description]
     * @param {Function} callback [description]
     * @constructor
     */

    function Unzipper(options, callback) {
        this.init(options, callback);
    }

    /**
     * Method configure class
     * @param  {Object}   option
     * @param  {Function} callback
     * @return {void}
     */
    Unzipper.prototype.init = function __doneInit(options, callback) {
        if(callback)
            callback(null, {success: true});
    }

    /**
     * Start method for unzip file
     * @param  {Object}   options  {from : 'String', to:'String'}
     * @param  {Function} callback [description]
     */
    Unzipper.prototype.start = function init(options, callback) {
        if(callback)
            callback(null, {success: true});
    }

     /**
     * Convert path string to correct format
     * @param  {String} pathString [description]
     * @example            normalizePath('/mtd_down')          /mtd_down
     * @example            normalizePath('/mtd_down/common')   /mtd_down/common
     * @example            normalizePath('/mtd_down/anyone')   /mtd_down/anyone
     * @example            normalizePath('/test')              /mtd_down/common/test
     * @return {String}
     */
    function normalizePath (pathString) {

        pathString = (pathString[0] == '/')    ?    pathString    :    '/' + pathString;
        pathString = (pathString[pathString.length -1] == '/')    ?    pathString.substring(0, pathString.length-1)    :    pathString;

        if(!pathString.match('/mtd_down'))
            pathString = pathString.match('/mtd_down/common') ? pathString : '/mtd_down/common' + pathString;


        return pathString;
    }
    /**
     * Extract file from path or URL
     * @return {String} file.txt
     */
    function extractFileFromPath(pathString) {
        var file;

        if(typeof pathString != 'string')
            return '';

        pathString = pathString.split('/');
        file = pathString[pathString.length-1];

        if(file.indexOf('.') > -1)
            return file;
        else
            return '';
    }

    _global.Unzipper = Unzipper;
})(this);


/**
 *
 *    var unzipper =  new Unzipper({
 *        fileSystemPlugin : document.querySelector('#FileSystemPlugin')
 *    });
 *
 *    unzipper.start({
 *        from: '/mtd_down/common/test/file.zip',
 *        to: '/mtd_down/common/test',
 *    }, function(error, data){
 *        console.log('complete', error, data)
 *    });
 *
 **/
