function scriptWebView () {

    var errosPage = undefined;
    ////////////////////
    // tratando erros //
    ////////////////////
    window.addEventListener('error', function( event ){
        // em caso de erro, ele será registrado
        errosPage = {
            message: event.message,
            filename: event.filename,
            lineno: event.lineno,
        };
    });

    /**
     * Objeto com método para trocar o conteúdo não temporizado da playlist principal
     * @type {Object}
     */
    window.Android = {
        /**
         * Método para trocar o conteúdo
         *
         * @method finish
         * @return {void}
         */
        finish: function () {
            // seta a variável
            AreaInterface.nextNews();

        }
    };

    var objExit = {
        direction: 0,
        msg: 'Notícia não foi trocada.',
        data: undefined,
        status: false,
        error: false,
        exception: {},
    };

    /**
     * Evento para capturar todas as verificações para conteúdos não temporizados
     *
     * @event message
     * @param  {Object} event
     * @return {void}
     */
    addEventListener('message', function doneEventMessage(event) {
        // caso exista erros na página
        if (errosPage) {
            objExit.error = 1;
            objExit.exception = errosPage;
            errosPage = {};

            // envia
            return sendMessage(event, objExit);
        }

        // caso o postMessage que esteje chegando não seja enviado do player
        if (!('data' in event) || !(typeof event.data === 'object')) {
            return;
        }

        // para tratar o tipo de player
        // TODO: para o valor 'webOS' para uma constante
        if ('typePlayer' in event.data && event.data.typePlayer == 'webOS') {
            window.isWebOS = true;
        }

        // objeto data
        objExit.data = event.data,

        // verifica se o conteúdo é temporizado
        AreaInterface.contentNoTimeout(event);

        // caso seja para executar um script
        if ('script' in event.data && event.data.script) {
            return eval(event.data.msg);
        }

        // troca a notícia caso seja uma das áreas auxiliares
        if (typeof AreaInterface != 'undefined' && AreaInterface.newNews) {

            ////////////////////////////////
            // caso seja a área principal //
            ////////////////////////////////
            window.AreaInterface.timeoutNotTime = undefined;
            window.AreaInterface.newNews = false;


            //////////////////////////////
            // caso seja áres do layout //
            //////////////////////////////
            {
                // em caso de errors
                try {
                    // troca a notícia
                    AreaInterface.loadNewsTemplate(event);
                } catch(error) {
                    // o template deve ser recarregado
                    objExit.error = 1;
                    objExit.exception = {
                        message: error.message,
                        filename: error.filename,
                        lineno: error.lineno,
                    };
                }
            }

            // response para player que trocou a notícia
            objExit.status = true;
            objExit.msg = 'Notícia trocada';
            return sendMessage(event, objExit);
        }
        // event.source.postMessage(objExit, event.origin);
    });

    /**
     * Método para enviar a mensagem
     * @param  {Object} event
     * @param  {JSON} data
     * @return {void}
     */
    function sendMessage(event, data) {
        event.source.postMessage(data, event.origin);
    }

    /**
     * Objeto com método para trocar o conteúdo do template
     *
     * @class AreaInterface
     * @type {Object}
     */
    window.AreaInterface = {
        newNews: false,
        /**
         * Método para trocar o valor da variável de controle de troca de conteúdo
         *
         * @method nextNews
         * @return {void}
         */
        nextNews: function AreaInterfaceNextNews() {
            window.AreaInterface.newNews = true;
        },
        /**
         * Método para trocar o conteúdo do template
         *
         * @method loadNewsTemplate
         * @param  {Event} event
         * @return {void}
         */
        loadNewsTemplate: function (event) {
            // verifica objeto
            if (('data' in event) || ('news' in event.data)) {

                var response = event.data.news;
                if( (typeof(response) == 'string') && (response.indexOf('&') !== -1 )){
                    response = response.slice(response.indexOf(".html?")+6);

                    // codificação
                    var rss = response;

                    try {
                        rss = decodeURIComponent(response);
                    } catch (errorException) {}

                    // verifica se existe a função parseQueryString
                    if (typeof window.parseQueryString === 'function' ) {
                        rss = window.parseQueryString(rss);

                        // verifica se existe a função
                        if (typeof window.loadNews == 'function') {
                            window.loadNews(rss.imgVar, rss.txtVar);
                            // faz com que o marquee execute novamente
                            if (typeof $mq != 'undefined') {
                                $mq.marquee({
                                    duration: 12000
                                });
                            }
                        }

                        return;
                    }

                    // em caso de erro. A função parseQueryString deve existir no template
                    // objExit.error = 1;
                    // objExit.exception = 'A função "parseQueryString" não existe no template.';
                    // errosPage = {};

                    // // envia
                    // return sendMessage(event, objExit);

                }
            }

            window.AreaInterface.newNews = false;
        },

        /**
         * Método para substituir método de troca de conteúdo padrão do layout
         *
         * @method contentNoTimeout
         * @param  {Event} event
         * @return {void}
         */
        contentNoTimeout: function AreaInterfaceContentNoTimeout(event) {

            // console.log("typeof window.loadNews", typeof window.loadNews, (typeof window.loadNews != "function"));

            // verifica se a função pra carregar notícia existe
            if (
                (typeof window.loadNews != "function" && AreaInterface.timeoutNotTime == undefined) && // conteúdo de notícia ou html comum
                window.getCourseJson === undefined //conteúdo do designer
            ) {
                AreaInterface.timeoutNotTime = setTimeout(function doneTimeOutContentNoTimeout() {
                    // seta a variável
                    AreaInterface.nextNews();

                    AreaInterface.timeoutNotTime = undefined;
                }, event.data.time);
            }
        },
        timeoutNotTime: undefined
    };

    // faz com que os templates não tenham barra de rolagem
    window.document.body.style.overflowX = 'hidden';
    window.document.body.style.overflowY = 'hidden';
};
