'use strict';

(function() {

	// Deals with synchronization to Google Drive
	chrome.syncFileSystem.requestFileSystem(function (fs) {
   		// 	// FileSystem API should just work on the returned 'fs'.
	   // fs.root.getFile('test.txt', {create:true}, getEntryCallback, errorCallback);

		console.log('Obtaining syncable FileSystem...', fs);	  

	   	// @todo understand what this part does
		if (!chrome || !chrome.syncFileSystem ||
		  !chrome.syncFileSystem.requestFileSystem) {
		  	console.log ('did not work yet');
			error('Syncable FileSystem is not supported in your environment.');
			return;
		}

		// Set Conflict Resolution Policy
		if (chrome.syncFileSystem.setConflictResolutionPolicy) {
			chrome.syncFileSystem.setConflictResolutionPolicy('last_write_win');
		}
		log('Obtaining syncable FileSystem...');	   

		// Return in case of error
		if (chrome.runtime.lastError) {
			error('requestFileSystem: ' + chrome.runtime.lastError.message);
			return;
		}
		onFileSystemOpened(fs, true);

	});

	// Called when syncFileSystem gets available
	function onFileSystemOpened(fs, isSyncable) {
	  log('Got Syncable FileSystem.'  + fs.name );

	  // var editor = new Editor(fs, 'editor');
	  // var filer = new Filer(fs, 'filer', editor, isSyncable);
	  // editor.filer = filer;

		chrome.fileSystem.getDisplayPath(fs.root, function ( displayPath ){
			console.log('displayPath:',  displayPath);
			log("displayPath: " + displayPath);
		});

		// chrome.fileSystem.getWritableEntry(fs.root, function (wEntry){

		//   wEntry.createWriter(function(writer) {

		//     writer.onerror = errorHandler;
		//     writer.onwriteend = callback;

		//     // If we have data, write it to the file. Otherwise, just use the file we
		//     // loaded.
		//     if (opt_blob) {
		//       writer.truncate(opt_blob.size);
		//       waitForIO(writer, function() {
		//         writer.seek(0);
		//         writer.write(opt_blob);
		//       });
		//     } 
		//     else {
		//       chosenEntry.file(function(file) {
		//         writer.truncate(file.fileSize);
		//         waitForIO(writer, function() {
		//           writer.seek(0);
		//           writer.write(file);
		//         });
		//       });
		//     }
		//   }, errorHandler);

		// });	
	  // var reader = fs.createReader();
	  // log(reader);
	  // reader.readEntries(function( files){
	  // 	log(files);
   //     for (var i = 0, len = files.length; i < len; i++) { 
   //         if(files[i].isFile) { 
   //             // FSA.getFile(files[i].name); 
   //             log('files[i]:' + files[i]);
   //         } 
   //     } 

	  // }, function(){error('error reading entries')});

	  if (isSyncable) {
	    if (chrome.syncFileSystem.onFileStatusChanged) {
	      chrome.syncFileSystem.onFileStatusChanged.addListener(
	          function(detail) {
	            if (detail.direction == 'remote_to_local') {
	              info('File ' + detail.fileEntry.fullPath +
	                   ' is ' + detail.action + ' by background sync.');
	            }
	            this.reload();
	          });
	    }
	    if (chrome.syncFileSystem.onServiceStatusChanged) {
	      chrome.syncFileSystem.onServiceStatusChanged.addListener(
	          function(detail) {
	            log('Service state updated: ' + detail.state + ': '
	                + detail.description);
	          });
	    }
	  }

	}	

	errorHandler = function(){};

})();