function info(msg) {
	console.log('INFO: ', arguments);
	var e = document.getElementById('message');
	e.innerText = msg;
	window.setTimeout(function() {
		e.innerHTML = '';
	}, 5000);
}

function log(msg) {
	document.getElementById('message').innerHTML = msg;
	console.log(msg, arguments);
}

function error(msg) {
	console.log('ERROR: ', arguments);
	var message = '';
	for (var i = 0; i < arguments.length; i++) {
		var description = '';
		if (arguments[i] instanceof FileError) {
			switch (arguments[i].code) {
				case FileError.QUOTA_EXCEEDED_ERR:
					description = 'QUOTA_EXCEEDED_ERR';
					break;
				case FileError.NOT_FOUND_ERR:
					description = 'NOT_FOUND_ERR';
					break;
				case FileError.SECURITY_ERR:
					description = 'SECURITY_ERR';
					break;
				case FileError.INVALID_MODIFICATION_ERR:
					description = 'INVALID_MODIFICATION_ERR';
					break;
				case FileError.INVALID_STATE_ERR:
					description = 'INVALID_STATE_ERR';
					break;
				default:
					description = 'Unknown Error';
					break;
			}
			message += ': ' + description;
		} else if (arguments[i].fullPath) {
			message += arguments[i].fullPath + ' ';
		} else {
			message += arguments[i] + ' ';
		}
	}
	var e = document.getElementById('error');
	e.innerText = 'ERROR:' + message;
	// e.classList.remove('hide');
	window.setTimeout(function() {
		e.innerHTML = '';
	}, 5000);
}

Function.prototype.inheritsFrom = function(parentClassOrObject) {
	if (parentClassOrObject.constructor == Function) {
		//Normal Inheritance
		this.prototype = new parentClassOrObject;
		this.prototype.constructor = this;
		this.prototype.parent = parentClassOrObject.prototype;
	} else {
		//Pure Virtual Inheritance
		this.prototype = parentClassOrObject;
		this.prototype.constructor = this;
		this.prototype.parent = parentClassOrObject;
	}
	return this;
}

// function googleAuth(callback) {
//   chrome.identity.getAuthToken({'interactive': true}, function(token) {
//     console.log('token: ', token);
//     if (token) {
//       callback(token, null);
//     } else {
//       // console.error(chrome.runtime.lastError);
//       callback(null, chrome.runtime.lastError);
//     }
//   });
// }

function gapiIsLoaded() {
	console.log('gapi is loaded');
}

/**
 * Método para redimensionar o vídeo
 *
 * @method resizeVideo
 * @param  {Element} videoElement
 * @return {void}
 */
function resizeVideo(videoElement) {

    // Y
    // var iOriginalVideoHeight = videoElement.videoHeight;
    var iCurrentVideoHeight = $(videoElement).height();
    var iVideoContainerHeight = $(videoElement.parentElement).height();
    // var iCurrentScale = iOriginalVideoHeight / iCurrentVideoHeight;
    // var iScaleY = (iVideoContainerHeight / iOriginalVideoHeight) * iCurrentScale;

    // // X
    // var iOriginalVideoWidth = videoElement.videoWidth;
    var iCurrentVideoWidth = $(videoElement).width();
    var iVideoContainerWidth = $(videoElement.parentElement).width();
    // var iCurrentScaleW = iOriginalVideoWidth / iCurrentVideoWidth;
    // var iScaleX = (iVideoContainerWidth / iOriginalVideoWidth) * iCurrentScaleW;

    var topContainer = $(videoElement.parentElement).css('top');

    var configVideo = {};

    // CASO NÃO SEJA INFORMADO -1, A TV COLOCA O VÍDEO EM FULLSCREEN (VERSÃO 1.2)

    // caso a largura do vídeo seja maior que altura
    if (iCurrentVideoWidth > iCurrentVideoHeight) {

        configVideo = {
            height: iVideoContainerHeight + 'px',
            width: (iVideoContainerWidth - 1) + 'px',
        };

        // caso a largura seja maior que área disponível para o vídeo
        if (iCurrentVideoWidth >= iVideoContainerWidth) {
            configVideo = {
                width: (iVideoContainerWidth - 1) + 'px',
            };
        }
    } else { //caso a altura do vídeo seja maior que a largura
        configVideo = {
            height: (iVideoContainerHeight - 1) + 'px',
            width: iVideoContainerWidth + 'px',
        };

        // caso a altura seja maior que área disponível para o vídeo
        if (iCurrentVideoWidth >= iVideoContainerHeight) {
            configVideo = {
                height: (iVideoContainerHeight - 1) + 'px',
            };
        }
    }

    // Aplica a proporção
    $(videoElement).css(
        _.extend(
            configVideo,
            {
                'top': topContainer
            }
        )
    );

    // // Aplica a proporção
    // $(videoElement).css({
    //     "width": iVideoContainerWidth + 'px',
    //     // "height": '100%',
    //     "height": iVideoContainerHeight + 'px',
    //     "top": topContainer,
    //     // "transform-origin": "0% 0%",
    //     // "transform": "scaleY(" + iScaleY + ")",
    //     // "-webkit-transform-origin": "0% 0%",
    //     // "-webkit-transform": "scaleY(" + iScaleY + ")",
    //     // "transform": "scaleX(" + iScaleX + ")",
    //     // "-webkit-transform": "scaleX(" + iScaleX + ")",
    // });
}

/**
 * Método para redimensionar a webview
 *
 * @method resizeWebview
 * @param  {Element} element
 * @return {void}
 */
function resizeWebview(element, container) {
    var width = jQuery(container).width();
    var height = jQuery(container).height();

    jQuery(element).width(width + 'px');
    jQuery(element).height(height + 'px');
}

/**
 * Método para alterar todos os elementos dentro de um container
 *
 * @method resizeAll
 * @param  {Array[Element]} container
 * @return {void}
 */
function resizeAll (container) {
    var i, video, webview, containerTmp;

    for (i in container) {

        // caso os elementos ainda não existirem
        if (container[i] === undefined) {
            continue;
        }

        // gamp
        containerTmp = ('querySelector' in container[i]? container[i] : container[i].getElementHtml());

        video = containerTmp.querySelector('video');
        webview = containerTmp.querySelector('iframe');

        // altera o tamanho
        resizeWebview(webview, containerTmp);
        resizeVideo(video);
    }
}

function makeslug(val, replaceBy) {
  replaceBy = replaceBy || '-';
  var mapaAcentosHex    = { // by @marioluan and @lelotnk
    a : /[\xE0-\xE6]/g,
    A : /[\xC0-\xC6]/g,
    e : /[\xE8-\xEB]/g, // if you're gonna echo this
    E : /[\xC8-\xCB]/g, // JS code through PHP, do
    i : /[\xEC-\xEF]/g, // not forget to escape these
    I : /[\xCC-\xCF]/g, // backslashes (\), by repeating
    o : /[\xF2-\xF6]/g, // them (\\)
    O : /[\xD2-\xD6]/g,
    u : /[\xF9-\xFC]/g,
    U : /[\xD9-\xDC]/g,
    c : /\xE7/g,
    C : /\xC7/g,
    n : /\xF1/g,
    N : /\xD1/g,
  };

  for ( var letra in mapaAcentosHex ) {
    var expressaoRegular = mapaAcentosHex[letra];
    val = val.replace( expressaoRegular, letra );
  }

  val = val.toLowerCase();
  val = val.replace(/[^a-z0-9\-]/g, " ");

  do {
    val = val.replace('  ', ' ');
  } while (val.indexOf('  ')>-1);

  val = val.trim();
  val = val.replace(/\s/g, replaceBy);

  return val;
}

/**
 * Extendento class do Jquery
 * @return {void}
 */
jQuery.extend({

  /**
   * Método para transformar os parâmetro de querystring para objeto
   *
   * @method getQueryParameters
   * @param  {string} str
   * @return {object}
   */
  getQueryParameters : function(str) {
      return (str || document.location.search).replace(/(^\?)/,'').split("&").map(function(n){return n = n.split("="),this[n[0]] = n[1],this}.bind({}))[0];
  }

});

/**
 * Método para verificar se o vídeo tem áudio
 *
 * @method hasAudio
 * @param  {Element}  video
 * @return {Boolean}
 */
function hasAudio (video) {
    return video.mozHasAudio || !!video.webkitAudioDecodedByteCount || video.audioTracks && !!video.audioTracks.length;
}

/**
 * Método para poder fazer com que o script aguarde antes de continuar
 *
 * @method sleepFor
 * @param  {integer} sleepDuration Em microsegundos
 * @return {void}
 */
function sleepFor( sleepDuration ){
    var now = new Date().getTime();
    while(new Date().getTime() < now + sleepDuration){ /* do nothing */ }
}

Function.prototype.clone = function() {
    var fct = this;
    var clone = function() {
        return fct.apply(this, arguments);
    };
    clone.prototype = fct.prototype;
    for (property in fct) {
        if (fct.hasOwnProperty(property) && property !== 'prototype') {
            clone[property] = fct[property];
        }
    }
    return clone;
};

function generateScriptText(fn) {

  // fn is going to be interpreted as a quoted string literal. As such, we need
  // to escape double-quotes in the string, and either:
  // (a) strip newlines and comments, or
  // (b) replace newlines with the character sequence "\n" (a slash followed by
  //     an n) and allow comments to be parsed as part of the function.

  // (a):
  // var fnText = fn.toString()
  //   .replace(/"/g, '\\"')                         // Escape double-quotes.
  //   .replace(/[/][/].*\r?\n/g, ' ')               // Rmv single-line comments.
  //   .replace(/\r?\n|\r/g, ' ')                    // Rmv newlines.
  //   .replace(/[/][*]((?![*][/]).)*[*][/]/g, ' '); // Rmv multi-line comments.

  // (b):
  var fnText = fn.toString()
    .replace(/"/g, '\\"')           // Escape double-quotes.
    .replace(/(\r?\n|\r)/g, '\\n'); // Insert newlines correctly.

  var scriptText =
      '(function() {\n' +
      '  var script = document.createElement("script");\n' +
      '  script.innerHTML = "(function() { (' + fnText + ')(); })()" \n'+
      '  document.body.appendChild(script);\n' +
      '})()';
  return scriptText;
}

//Função responsável por fazer o parse dos dados da notícia passados como parâmetro através da chamada da url
function parseQueryString (queryString) {
    if(typeof(queryString) != 'string'){
        return queryString;
    }

    if(queryString[0] == '?'){
      queryString = queryString.substring(1, queryString.length);
    }

    var params = {}, queries, temp, i, l;
    queries = queryString.split('&');

    for ( i = 0, l = queries.length; i < l; i++ ) {
      temp = queries[i].split('=');
      params[temp[0]] = temp[1];
    }

    return params;
}

/**
 * Método para escapar conteúdo html
 * @param  {string} unsafe
 * @return {strin}
 */
function escapeHtml(unsafe) {
    return unsafe
         .replace(/&/g, "&amp;")
         .replace(/</g, "&lt;")
         .replace(/>/g, "&gt;")
         .replace(/"/g, "&quot;")
         .replace(/'/g, "&#039;");
 }

/**
 * Método para converter conteúdo no formato de ArrayBuffer para string
 * @param  {ArrayBuffer} arrayBuffer
 * @param  {function} onSuccess
 * @param  {function} onFail
 * @return {void}
 */
function readBinaryStringFromArrayBuffer (arrayBuffer, onSuccess, onFail) {
  var reader = new FileReader();
  reader.onload = function (event) {
    onSuccess(event.target.result);
  };
  reader.onerror = function (event) {
    onFail(event.target.error);
  };
  reader.readAsBinaryString(new Blob([ arrayBuffer ],
    { type: 'application/octet-stream' }));
}

function ab2str(buf) {
  return String.fromCharCode.apply(null, new Uint16Array(buf));
}

/**
 * Método para converter string para uft-8
 * @param  {string} s
 * @return {string}
 */
function decode_utf8(s) {
  return decodeURIComponent(escape(s));
}

